/* page.c generated by valac 0.42.3, the Vala compiler
 * generated from page.vala, do not modify */

/*
 * Copyright (C) 2009-2015 Canonical Ltd.
 * Author: Robert Ancell <robert.ancell@canonical.com>
 *
 * This program is free software: you can redistribute it and/or modify it under
 * the terms of the GNU General Public License as published by the Free Software
 * Foundation, either version 3 of the License, or (at your option) any later
 * version. See http://www.gnu.org/copyleft/gpl.html the full text of the
 * license.
 */


#include <glib.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <float.h>
#include <math.h>
#include <gdk-pixbuf/gdk-pixbuf.h>
#include <glib/gstdio.h>
#include <gtk/gtk.h>
#include <gdk/gdk.h>
#include <gio/gio.h>
#include <gobject/gvaluecollector.h>


#define TYPE_SCAN_DIRECTION (scan_direction_get_type ())

#define TYPE_PAGE (page_get_type ())
#define PAGE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_PAGE, Page))
#define PAGE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_PAGE, PageClass))
#define IS_PAGE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_PAGE))
#define IS_PAGE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_PAGE))
#define PAGE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_PAGE, PageClass))

typedef struct _Page Page;
typedef struct _PageClass PageClass;
typedef struct _PagePrivate PagePrivate;
#define _g_free0(var) (var = (g_free (var), NULL))

#define TYPE_SCAN_PAGE_INFO (scan_page_info_get_type ())
#define SCAN_PAGE_INFO(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_SCAN_PAGE_INFO, ScanPageInfo))
#define SCAN_PAGE_INFO_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_SCAN_PAGE_INFO, ScanPageInfoClass))
#define IS_SCAN_PAGE_INFO(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_SCAN_PAGE_INFO))
#define IS_SCAN_PAGE_INFO_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_SCAN_PAGE_INFO))
#define SCAN_PAGE_INFO_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_SCAN_PAGE_INFO, ScanPageInfoClass))

typedef struct _ScanPageInfo ScanPageInfo;
typedef struct _ScanPageInfoClass ScanPageInfoClass;
typedef struct _ScanPageInfoPrivate ScanPageInfoPrivate;

#define TYPE_SCAN_LINE (scan_line_get_type ())
#define SCAN_LINE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_SCAN_LINE, ScanLine))
#define SCAN_LINE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_SCAN_LINE, ScanLineClass))
#define IS_SCAN_LINE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_SCAN_LINE))
#define IS_SCAN_LINE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_SCAN_LINE))
#define SCAN_LINE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_SCAN_LINE, ScanLineClass))

typedef struct _ScanLine ScanLine;
typedef struct _ScanLineClass ScanLineClass;
typedef struct _ScanLinePrivate ScanLinePrivate;
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
typedef struct _Block6Data Block6Data;
#define _page_unref0(var) ((var == NULL) ? NULL : (var = (page_unref (var), NULL)))
typedef struct _ParamSpecPage ParamSpecPage;
enum  {
	PAGE_PIXELS_CHANGED_SIGNAL,
	PAGE_SIZE_CHANGED_SIGNAL,
	PAGE_SCAN_LINE_CHANGED_SIGNAL,
	PAGE_SCAN_DIRECTION_CHANGED_SIGNAL,
	PAGE_CROP_CHANGED_SIGNAL,
	PAGE_SCAN_FINISHED_SIGNAL,
	PAGE_NUM_SIGNALS
};
static guint page_signals[PAGE_NUM_SIGNALS] = {0};

typedef enum  {
	SCAN_DIRECTION_TOP_TO_BOTTOM,
	SCAN_DIRECTION_LEFT_TO_RIGHT,
	SCAN_DIRECTION_BOTTOM_TO_TOP,
	SCAN_DIRECTION_RIGHT_TO_LEFT
} ScanDirection;

struct _Page {
	GTypeInstance parent_instance;
	volatile int ref_count;
	PagePrivate * priv;
};

struct _PageClass {
	GTypeClass parent_class;
	void (*finalize) (Page *self);
};

struct _PagePrivate {
	gint _dpi;
	gint expected_rows;
	gint _depth;
	gchar* _color_profile;
	gint _scan_width;
	gint _scan_height;
	gint _rowstride;
	gint _n_channels;
	guchar* pixels;
	gint pixels_length1;
	gint _pixels_size_;
	gboolean _is_scanning;
	gboolean _has_data;
	gint _scan_line;
	ScanDirection scan_direction_;
	gboolean _has_crop;
	gchar* _crop_name;
	gint _crop_x;
	gint _crop_y;
	gint _crop_width;
	gint _crop_height;
};

struct _ScanPageInfo {
	GTypeInstance parent_instance;
	volatile int ref_count;
	ScanPageInfoPrivate * priv;
	gint width;
	gint height;
	gint depth;
	gint n_channels;
	gdouble dpi;
	gchar* device;
};

struct _ScanPageInfoClass {
	GTypeClass parent_class;
	void (*finalize) (ScanPageInfo *self);
};

struct _ScanLine {
	GTypeInstance parent_instance;
	volatile int ref_count;
	ScanLinePrivate * priv;
	gint number;
	gint n_lines;
	gint width;
	gint depth;
	gint channel;
	guchar* data;
	gint data_length1;
	gint data_length;
};

struct _ScanLineClass {
	GTypeClass parent_class;
	void (*finalize) (ScanLine *self);
};

struct _Block6Data {
	int _ref_count_;
	Page* self;
	GFileOutputStream* stream;
};

struct _ParamSpecPage {
	GParamSpec parent_instance;
};


static gint Page_private_offset;
static gpointer page_parent_class = NULL;

GType scan_direction_get_type (void) G_GNUC_CONST;
gpointer page_ref (gpointer instance);
void page_unref (gpointer instance);
GParamSpec* param_spec_page (const gchar* name,
                             const gchar* nick,
                             const gchar* blurb,
                             GType object_type,
                             GParamFlags flags);
void value_set_page (GValue* value,
                     gpointer v_object);
void value_take_page (GValue* value,
                      gpointer v_object);
gpointer value_get_page (const GValue* value);
GType page_get_type (void) G_GNUC_CONST;
Page* page_new (gint width,
                gint height,
                gint dpi,
                ScanDirection scan_direction);
Page* page_construct (GType object_type,
                      gint width,
                      gint height,
                      gint dpi,
                      ScanDirection scan_direction);
static void page_set_scan_width (Page* self,
                          gint value);
static void page_set_scan_height (Page* self,
                           gint value);
static void page_set_dpi (Page* self,
                   gint value);
void page_set_scan_direction (Page* self,
                              ScanDirection value);
Page* page_new_from_data (gint scan_width,
                          gint scan_height,
                          gint rowstride,
                          gint n_channels,
                          gint depth,
                          gint dpi,
                          ScanDirection scan_direction,
                          const gchar* color_profile,
                          guchar* pixels,
                          int pixels_length1,
                          gboolean has_crop,
                          const gchar* crop_name,
                          gint crop_x,
                          gint crop_y,
                          gint crop_width,
                          gint crop_height);
Page* page_construct_from_data (GType object_type,
                                gint scan_width,
                                gint scan_height,
                                gint rowstride,
                                gint n_channels,
                                gint depth,
                                gint dpi,
                                ScanDirection scan_direction,
                                const gchar* color_profile,
                                guchar* pixels,
                                int pixels_length1,
                                gboolean has_crop,
                                const gchar* crop_name,
                                gint crop_x,
                                gint crop_y,
                                gint crop_width,
                                gint crop_height);
static void page_set_rowstride (Page* self,
                         gint value);
static void page_set_n_channels (Page* self,
                          gint value);
static void page_set_depth (Page* self,
                     gint value);
void page_set_color_profile (Page* self,
                             const gchar* value);
static guchar* _vala_array_dup5 (guchar* self,
                          int length);
static void page_set_has_data (Page* self,
                        gboolean value);
static void page_set_has_crop (Page* self,
                        gboolean value);
static void page_set_crop_name (Page* self,
                         const gchar* value);
static void page_set_crop_x (Page* self,
                      gint value);
static void page_set_crop_y (Page* self,
                      gint value);
static void page_set_crop_width (Page* self,
                          gint value);
static void page_set_crop_height (Page* self,
                           gint value);
gpointer scan_page_info_ref (gpointer instance);
void scan_page_info_unref (gpointer instance);
GParamSpec* param_spec_scan_page_info (const gchar* name,
                                       const gchar* nick,
                                       const gchar* blurb,
                                       GType object_type,
                                       GParamFlags flags);
void value_set_scan_page_info (GValue* value,
                               gpointer v_object);
void value_take_scan_page_info (GValue* value,
                                gpointer v_object);
gpointer value_get_scan_page_info (const GValue* value);
GType scan_page_info_get_type (void) G_GNUC_CONST;
void page_set_page_info (Page* self,
                         ScanPageInfo* info);
gint page_get_scan_height (Page* self);
gint page_get_scan_width (Page* self);
gint page_get_depth (Page* self);
gint page_get_n_channels (Page* self);
gint page_get_rowstride (Page* self);
void page_start (Page* self);
static void page_set_is_scanning (Page* self,
                           gboolean value);
gpointer scan_line_ref (gpointer instance);
void scan_line_unref (gpointer instance);
GParamSpec* param_spec_scan_line (const gchar* name,
                                  const gchar* nick,
                                  const gchar* blurb,
                                  GType object_type,
                                  GParamFlags flags);
void value_set_scan_line (GValue* value,
                          gpointer v_object);
void value_take_scan_line (GValue* value,
                           gpointer v_object);
gpointer value_get_scan_line (const GValue* value);
GType scan_line_get_type (void) G_GNUC_CONST;
static void page_parse_line (Page* self,
                      ScanLine* line,
                      gint n,
                      gboolean* size_changed);
static void page_set_scan_line (Page* self,
                         gint value);
void page_parse_scan_line (Page* self,
                           ScanLine* line);
void page_finish (Page* self);
gint page_get_scan_line (Page* self);
void page_rotate_left (Page* self);
ScanDirection page_get_scan_direction (Page* self);
void page_rotate_right (Page* self);
void page_set_no_crop (Page* self);
gboolean page_get_has_crop (Page* self);
void page_set_custom_crop (Page* self,
                           gint width,
                           gint height);
const gchar* page_get_crop_name (Page* self);
gint page_get_crop_width (Page* self);
gint page_get_crop_height (Page* self);
void page_set_named_crop (Page* self,
                          const gchar* name);
gint page_get_width (Page* self);
gint page_get_height (Page* self);
gint page_get_dpi (Page* self);
void page_move_crop (Page* self,
                     gint x,
                     gint y);
void page_rotate_crop (Page* self);
gint page_get_crop_x (Page* self);
gint page_get_crop_y (Page* self);
guchar* page_get_pixels (Page* self,
                         int* result_length1);
static guchar page_get_sample (Page* self,
                        guchar* pixels,
                        int pixels_length1,
                        gint offset,
                        gint x,
                        gint depth,
                        gint n_channels,
                        gint channel);
static void page_get_pixel (Page* self,
                     gint x,
                     gint y,
                     guchar* pixel,
                     int pixel_length1,
                     gint offset);
GdkPixbuf* page_get_image (Page* self,
                           gboolean apply_crop);
gchar* page_get_icc_data_encoded (Page* self);
const gchar* page_get_color_profile (Page* self);
void page_copy_to_clipboard (Page* self,
                             GtkWindow* window);
void page_save_png (Page* self,
                    GFile* file,
                    GError** error);
static Block6Data* block6_data_ref (Block6Data* _data6_);
static void block6_data_unref (void * _userdata_);
static gboolean __lambda17_ (Block6Data* _data6_,
                      guint8* buf,
                      int buf_length1,
                      GError** error);
static gboolean ___lambda17__gdk_pixbuf_save_func (guint8* buf,
                                            gsize buf_length1,
                                            GError** error,
                                            gpointer self);
gboolean page_get_is_landscape (Page* self);
gboolean page_get_is_scanning (Page* self);
gboolean page_get_has_data (Page* self);
gboolean page_get_is_color (Page* self);
static void page_finalize (Page * obj);
static void _vala_array_destroy (gpointer array,
                          gint array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gint array_length,
                       GDestroyNotify destroy_func);


GType
scan_direction_get_type (void)
{
	static volatile gsize scan_direction_type_id__volatile = 0;
	if (g_once_init_enter (&scan_direction_type_id__volatile)) {
		static const GEnumValue values[] = {{SCAN_DIRECTION_TOP_TO_BOTTOM, "SCAN_DIRECTION_TOP_TO_BOTTOM", "top-to-bottom"}, {SCAN_DIRECTION_LEFT_TO_RIGHT, "SCAN_DIRECTION_LEFT_TO_RIGHT", "left-to-right"}, {SCAN_DIRECTION_BOTTOM_TO_TOP, "SCAN_DIRECTION_BOTTOM_TO_TOP", "bottom-to-top"}, {SCAN_DIRECTION_RIGHT_TO_LEFT, "SCAN_DIRECTION_RIGHT_TO_LEFT", "right-to-left"}, {0, NULL, NULL}};
		GType scan_direction_type_id;
		scan_direction_type_id = g_enum_register_static ("ScanDirection", values);
		g_once_init_leave (&scan_direction_type_id__volatile, scan_direction_type_id);
	}
	return scan_direction_type_id__volatile;
}


static inline gpointer
page_get_instance_private (Page* self)
{
	return G_STRUCT_MEMBER_P (self, Page_private_offset);
}


Page*
page_construct (GType object_type,
                gint width,
                gint height,
                gint dpi,
                ScanDirection scan_direction)
{
	Page* self = NULL;
	gboolean _tmp0_ = FALSE;
#line 172 "../src/page.vala"
	self = (Page*) g_type_create_instance (object_type);
#line 174 "../src/page.vala"
	if (scan_direction == SCAN_DIRECTION_TOP_TO_BOTTOM) {
#line 174 "../src/page.vala"
		_tmp0_ = TRUE;
#line 414 "page.c"
	} else {
#line 174 "../src/page.vala"
		_tmp0_ = scan_direction == SCAN_DIRECTION_BOTTOM_TO_TOP;
#line 418 "page.c"
	}
#line 174 "../src/page.vala"
	if (_tmp0_) {
#line 176 "../src/page.vala"
		page_set_scan_width (self, width);
#line 177 "../src/page.vala"
		page_set_scan_height (self, height);
#line 426 "page.c"
	} else {
#line 181 "../src/page.vala"
		page_set_scan_width (self, height);
#line 182 "../src/page.vala"
		page_set_scan_height (self, width);
#line 432 "page.c"
	}
#line 184 "../src/page.vala"
	page_set_dpi (self, dpi);
#line 185 "../src/page.vala"
	page_set_scan_direction (self, scan_direction);
#line 172 "../src/page.vala"
	return self;
#line 440 "page.c"
}


Page*
page_new (gint width,
          gint height,
          gint dpi,
          ScanDirection scan_direction)
{
#line 172 "../src/page.vala"
	return page_construct (TYPE_PAGE, width, height, dpi, scan_direction);
#line 452 "page.c"
}


static guchar*
_vala_array_dup5 (guchar* self,
                  int length)
{
#line 213 "../src/page.vala"
	return g_memdup (self, length * sizeof (guchar));
#line 462 "page.c"
}


Page*
page_construct_from_data (GType object_type,
                          gint scan_width,
                          gint scan_height,
                          gint rowstride,
                          gint n_channels,
                          gint depth,
                          gint dpi,
                          ScanDirection scan_direction,
                          const gchar* color_profile,
                          guchar* pixels,
                          int pixels_length1,
                          gboolean has_crop,
                          const gchar* crop_name,
                          gint crop_x,
                          gint crop_y,
                          gint crop_width,
                          gint crop_height)
{
	Page* self = NULL;
	guchar* _tmp0_;
	gint _tmp0__length1;
#line 188 "../src/page.vala"
	self = (Page*) g_type_create_instance (object_type);
#line 204 "../src/page.vala"
	page_set_scan_width (self, scan_width);
#line 205 "../src/page.vala"
	page_set_scan_height (self, scan_height);
#line 206 "../src/page.vala"
	self->priv->expected_rows = scan_height;
#line 207 "../src/page.vala"
	page_set_rowstride (self, rowstride);
#line 208 "../src/page.vala"
	page_set_n_channels (self, n_channels);
#line 209 "../src/page.vala"
	page_set_depth (self, depth);
#line 210 "../src/page.vala"
	page_set_dpi (self, dpi);
#line 211 "../src/page.vala"
	page_set_scan_direction (self, scan_direction);
#line 212 "../src/page.vala"
	page_set_color_profile (self, color_profile);
#line 213 "../src/page.vala"
	_tmp0_ = (pixels != NULL) ? _vala_array_dup5 (pixels, pixels_length1) : ((gpointer) pixels);
#line 213 "../src/page.vala"
	_tmp0__length1 = pixels_length1;
#line 213 "../src/page.vala"
	self->priv->pixels = (g_free (self->priv->pixels), NULL);
#line 213 "../src/page.vala"
	self->priv->pixels = _tmp0_;
#line 213 "../src/page.vala"
	self->priv->pixels_length1 = _tmp0__length1;
#line 213 "../src/page.vala"
	self->priv->_pixels_size_ = self->priv->pixels_length1;
#line 214 "../src/page.vala"
	page_set_has_data (self, pixels != NULL);
#line 215 "../src/page.vala"
	page_set_has_crop (self, has_crop);
#line 216 "../src/page.vala"
	page_set_crop_name (self, crop_name);
#line 217 "../src/page.vala"
	page_set_crop_x (self, crop_x);
#line 218 "../src/page.vala"
	page_set_crop_y (self, crop_y);
#line 219 "../src/page.vala"
	page_set_crop_width (self, crop_width);
#line 220 "../src/page.vala"
	page_set_crop_height (self, crop_height);
#line 188 "../src/page.vala"
	return self;
#line 536 "page.c"
}


Page*
page_new_from_data (gint scan_width,
                    gint scan_height,
                    gint rowstride,
                    gint n_channels,
                    gint depth,
                    gint dpi,
                    ScanDirection scan_direction,
                    const gchar* color_profile,
                    guchar* pixels,
                    int pixels_length1,
                    gboolean has_crop,
                    const gchar* crop_name,
                    gint crop_x,
                    gint crop_y,
                    gint crop_width,
                    gint crop_height)
{
#line 188 "../src/page.vala"
	return page_construct_from_data (TYPE_PAGE, scan_width, scan_height, rowstride, n_channels, depth, dpi, scan_direction, color_profile, pixels, pixels_length1, has_crop, crop_name, crop_x, crop_y, crop_width, crop_height);
#line 560 "page.c"
}


void
page_set_page_info (Page* self,
                    ScanPageInfo* info)
{
	gint _tmp0_;
	gdouble _tmp1_;
	gint _tmp2_;
	gint _tmp3_;
	gint _tmp4_;
	gint _tmp6_;
	gint _tmp7_;
	gint _tmp8_;
	gint _tmp9_;
	gint _tmp10_;
	gint _tmp11_;
	gint _tmp12_;
	gint _tmp13_;
	guchar* _tmp14_;
	gint _tmp14__length1;
	gint _tmp15_;
#line 223 "../src/page.vala"
	g_return_if_fail (self != NULL);
#line 223 "../src/page.vala"
	g_return_if_fail (info != NULL);
#line 225 "../src/page.vala"
	_tmp0_ = info->height;
#line 225 "../src/page.vala"
	self->priv->expected_rows = _tmp0_;
#line 226 "../src/page.vala"
	_tmp1_ = info->dpi;
#line 226 "../src/page.vala"
	page_set_dpi (self, (gint) _tmp1_);
#line 229 "../src/page.vala"
	_tmp2_ = info->width;
#line 229 "../src/page.vala"
	page_set_scan_width (self, _tmp2_);
#line 230 "../src/page.vala"
	_tmp3_ = info->height;
#line 230 "../src/page.vala"
	page_set_scan_height (self, _tmp3_);
#line 232 "../src/page.vala"
	_tmp4_ = self->priv->_scan_height;
#line 232 "../src/page.vala"
	if (_tmp4_ < 0) {
#line 608 "page.c"
		gint _tmp5_;
#line 233 "../src/page.vala"
		_tmp5_ = self->priv->_scan_width;
#line 233 "../src/page.vala"
		page_set_scan_height (self, _tmp5_ / 2);
#line 614 "page.c"
	}
#line 234 "../src/page.vala"
	_tmp6_ = info->depth;
#line 234 "../src/page.vala"
	page_set_depth (self, _tmp6_);
#line 235 "../src/page.vala"
	_tmp7_ = info->n_channels;
#line 235 "../src/page.vala"
	page_set_n_channels (self, _tmp7_);
#line 236 "../src/page.vala"
	_tmp8_ = self->priv->_scan_width;
#line 236 "../src/page.vala"
	_tmp9_ = self->priv->_depth;
#line 236 "../src/page.vala"
	_tmp10_ = self->priv->_n_channels;
#line 236 "../src/page.vala"
	page_set_rowstride (self, (((_tmp8_ * _tmp9_) * _tmp10_) + 7) / 8);
#line 237 "../src/page.vala"
	_tmp11_ = self->priv->_scan_height;
#line 237 "../src/page.vala"
	_tmp12_ = self->priv->_rowstride;
#line 237 "../src/page.vala"
	_tmp13_ = _tmp11_ * _tmp12_;
#line 237 "../src/page.vala"
	self->priv->pixels = g_renew (guchar, self->priv->pixels, _tmp11_ * _tmp12_);
#line 237 "../src/page.vala"
	(_tmp13_ > self->priv->pixels_length1) ? memset (self->priv->pixels + self->priv->pixels_length1, 0, sizeof (guchar) * (_tmp13_ - self->priv->pixels_length1)) : NULL;
#line 237 "../src/page.vala"
	self->priv->pixels_length1 = _tmp13_;
#line 237 "../src/page.vala"
	self->priv->_pixels_size_ = _tmp13_;
#line 238 "../src/page.vala"
	_tmp14_ = self->priv->pixels;
#line 238 "../src/page.vala"
	_tmp14__length1 = self->priv->pixels_length1;
#line 238 "../src/page.vala"
	g_return_if_fail (_tmp14_ != NULL);
#line 241 "../src/page.vala"
	_tmp15_ = self->priv->_depth;
#line 241 "../src/page.vala"
	if (_tmp15_ == 1) {
#line 656 "page.c"
		guchar* _tmp16_;
		gint _tmp16__length1;
		gint _tmp17_;
		gint _tmp18_;
#line 242 "../src/page.vala"
		_tmp16_ = self->priv->pixels;
#line 242 "../src/page.vala"
		_tmp16__length1 = self->priv->pixels_length1;
#line 242 "../src/page.vala"
		_tmp17_ = self->priv->_scan_height;
#line 242 "../src/page.vala"
		_tmp18_ = self->priv->_rowstride;
#line 242 "../src/page.vala"
		memset (_tmp16_, 0x00, (gsize) (_tmp17_ * _tmp18_));
#line 671 "page.c"
	} else {
		guchar* _tmp19_;
		gint _tmp19__length1;
		gint _tmp20_;
		gint _tmp21_;
#line 244 "../src/page.vala"
		_tmp19_ = self->priv->pixels;
#line 244 "../src/page.vala"
		_tmp19__length1 = self->priv->pixels_length1;
#line 244 "../src/page.vala"
		_tmp20_ = self->priv->_scan_height;
#line 244 "../src/page.vala"
		_tmp21_ = self->priv->_rowstride;
#line 244 "../src/page.vala"
		memset (_tmp19_, 0xFF, (gsize) (_tmp20_ * _tmp21_));
#line 687 "page.c"
	}
#line 246 "../src/page.vala"
	g_signal_emit (self, page_signals[PAGE_SIZE_CHANGED_SIGNAL], 0);
#line 247 "../src/page.vala"
	g_signal_emit (self, page_signals[PAGE_PIXELS_CHANGED_SIGNAL], 0);
#line 693 "page.c"
}


void
page_start (Page* self)
{
#line 250 "../src/page.vala"
	g_return_if_fail (self != NULL);
#line 252 "../src/page.vala"
	page_set_is_scanning (self, TRUE);
#line 253 "../src/page.vala"
	g_signal_emit (self, page_signals[PAGE_SCAN_LINE_CHANGED_SIGNAL], 0);
#line 706 "page.c"
}


static void
page_parse_line (Page* self,
                 ScanLine* line,
                 gint n,
                 gboolean* size_changed)
{
	gboolean _vala_size_changed = FALSE;
	gint line_number = 0;
	gint _tmp0_;
	gint offset = 0;
	gint _tmp11_;
	gint _tmp12_;
	gint line_offset = 0;
	gint _tmp13_;
	gint _tmp26_;
#line 256 "../src/page.vala"
	g_return_if_fail (self != NULL);
#line 256 "../src/page.vala"
	g_return_if_fail (line != NULL);
#line 258 "../src/page.vala"
	_tmp0_ = line->number;
#line 258 "../src/page.vala"
	line_number = _tmp0_ + n;
#line 261 "../src/page.vala"
	_vala_size_changed = FALSE;
#line 262 "../src/page.vala"
	while (TRUE) {
#line 737 "page.c"
		gint _tmp1_;
		gint _tmp2_;
		gint rows = 0;
		gint _tmp3_;
		gint _tmp4_;
		gint _tmp5_;
		gint _tmp6_;
		gint _tmp7_;
		gint _tmp8_;
		gint _tmp9_;
		gint _tmp10_;
#line 262 "../src/page.vala"
		_tmp1_ = line_number;
#line 262 "../src/page.vala"
		_tmp2_ = self->priv->_scan_height;
#line 262 "../src/page.vala"
		if (!(_tmp1_ >= _tmp2_)) {
#line 262 "../src/page.vala"
			break;
#line 757 "page.c"
		}
#line 265 "../src/page.vala"
		_tmp3_ = self->priv->_scan_height;
#line 265 "../src/page.vala"
		rows = _tmp3_;
#line 266 "../src/page.vala"
		_tmp4_ = rows;
#line 266 "../src/page.vala"
		_tmp5_ = self->priv->_scan_width;
#line 266 "../src/page.vala"
		page_set_scan_height (self, _tmp4_ + (_tmp5_ / 2));
#line 267 "../src/page.vala"
		_tmp6_ = rows;
#line 267 "../src/page.vala"
		_tmp7_ = self->priv->_scan_height;
#line 267 "../src/page.vala"
		g_debug ("page.vala:267: Extending image from %d lines to %d lines", _tmp6_, _tmp7_);
#line 268 "../src/page.vala"
		_tmp8_ = self->priv->_scan_height;
#line 268 "../src/page.vala"
		_tmp9_ = self->priv->_rowstride;
#line 268 "../src/page.vala"
		_tmp10_ = _tmp8_ * _tmp9_;
#line 268 "../src/page.vala"
		self->priv->pixels = g_renew (guchar, self->priv->pixels, _tmp8_ * _tmp9_);
#line 268 "../src/page.vala"
		(_tmp10_ > self->priv->pixels_length1) ? memset (self->priv->pixels + self->priv->pixels_length1, 0, sizeof (guchar) * (_tmp10_ - self->priv->pixels_length1)) : NULL;
#line 268 "../src/page.vala"
		self->priv->pixels_length1 = _tmp10_;
#line 268 "../src/page.vala"
		self->priv->_pixels_size_ = _tmp10_;
#line 270 "../src/page.vala"
		_vala_size_changed = TRUE;
#line 791 "page.c"
	}
#line 274 "../src/page.vala"
	_tmp11_ = line_number;
#line 274 "../src/page.vala"
	_tmp12_ = self->priv->_rowstride;
#line 274 "../src/page.vala"
	offset = _tmp11_ * _tmp12_;
#line 275 "../src/page.vala"
	_tmp13_ = line->data_length;
#line 275 "../src/page.vala"
	line_offset = n * _tmp13_;
#line 803 "page.c"
	{
		gint i = 0;
#line 276 "../src/page.vala"
		i = 0;
#line 808 "page.c"
		{
			gboolean _tmp14_ = FALSE;
#line 276 "../src/page.vala"
			_tmp14_ = TRUE;
#line 276 "../src/page.vala"
			while (TRUE) {
#line 815 "page.c"
				gint _tmp16_;
				gint _tmp17_;
				guchar* _tmp18_;
				gint _tmp18__length1;
				gint _tmp19_;
				gint _tmp20_;
				guchar* _tmp21_;
				gint _tmp21__length1;
				gint _tmp22_;
				gint _tmp23_;
				guchar _tmp24_;
				guchar _tmp25_;
#line 276 "../src/page.vala"
				if (!_tmp14_) {
#line 830 "page.c"
					gint _tmp15_;
#line 276 "../src/page.vala"
					_tmp15_ = i;
#line 276 "../src/page.vala"
					i = _tmp15_ + 1;
#line 836 "page.c"
				}
#line 276 "../src/page.vala"
				_tmp14_ = FALSE;
#line 276 "../src/page.vala"
				_tmp16_ = i;
#line 276 "../src/page.vala"
				_tmp17_ = line->data_length;
#line 276 "../src/page.vala"
				if (!(_tmp16_ < _tmp17_)) {
#line 276 "../src/page.vala"
					break;
#line 848 "page.c"
				}
#line 277 "../src/page.vala"
				_tmp18_ = self->priv->pixels;
#line 277 "../src/page.vala"
				_tmp18__length1 = self->priv->pixels_length1;
#line 277 "../src/page.vala"
				_tmp19_ = offset;
#line 277 "../src/page.vala"
				_tmp20_ = i;
#line 277 "../src/page.vala"
				_tmp21_ = line->data;
#line 277 "../src/page.vala"
				_tmp21__length1 = line->data_length1;
#line 277 "../src/page.vala"
				_tmp22_ = line_offset;
#line 277 "../src/page.vala"
				_tmp23_ = i;
#line 277 "../src/page.vala"
				_tmp24_ = _tmp21_[_tmp22_ + _tmp23_];
#line 277 "../src/page.vala"
				_tmp18_[_tmp19_ + _tmp20_] = _tmp24_;
#line 277 "../src/page.vala"
				_tmp25_ = _tmp18_[_tmp19_ + _tmp20_];
#line 872 "page.c"
			}
		}
	}
#line 279 "../src/page.vala"
	_tmp26_ = line_number;
#line 279 "../src/page.vala"
	page_set_scan_line (self, _tmp26_);
#line 256 "../src/page.vala"
	if (size_changed) {
#line 256 "../src/page.vala"
		*size_changed = _vala_size_changed;
#line 884 "page.c"
	}
}


void
page_parse_scan_line (Page* self,
                      ScanLine* line)
{
	gboolean size_has_changed = FALSE;
	gboolean _tmp6_;
#line 282 "../src/page.vala"
	g_return_if_fail (self != NULL);
#line 282 "../src/page.vala"
	g_return_if_fail (line != NULL);
#line 284 "../src/page.vala"
	size_has_changed = FALSE;
#line 901 "page.c"
	{
		gint i = 0;
#line 285 "../src/page.vala"
		i = 0;
#line 906 "page.c"
		{
			gboolean _tmp0_ = FALSE;
#line 285 "../src/page.vala"
			_tmp0_ = TRUE;
#line 285 "../src/page.vala"
			while (TRUE) {
#line 913 "page.c"
				gint _tmp2_;
				gint _tmp3_;
				gint _tmp4_;
				gboolean _tmp5_ = FALSE;
#line 285 "../src/page.vala"
				if (!_tmp0_) {
#line 920 "page.c"
					gint _tmp1_;
#line 285 "../src/page.vala"
					_tmp1_ = i;
#line 285 "../src/page.vala"
					i = _tmp1_ + 1;
#line 926 "page.c"
				}
#line 285 "../src/page.vala"
				_tmp0_ = FALSE;
#line 285 "../src/page.vala"
				_tmp2_ = i;
#line 285 "../src/page.vala"
				_tmp3_ = line->n_lines;
#line 285 "../src/page.vala"
				if (!(_tmp2_ < _tmp3_)) {
#line 285 "../src/page.vala"
					break;
#line 938 "page.c"
				}
#line 286 "../src/page.vala"
				_tmp4_ = i;
#line 286 "../src/page.vala"
				page_parse_line (self, line, _tmp4_, &_tmp5_);
#line 286 "../src/page.vala"
				size_has_changed = _tmp5_;
#line 946 "page.c"
			}
		}
	}
#line 288 "../src/page.vala"
	page_set_has_data (self, TRUE);
#line 290 "../src/page.vala"
	_tmp6_ = size_has_changed;
#line 290 "../src/page.vala"
	if (_tmp6_) {
#line 291 "../src/page.vala"
		g_signal_emit (self, page_signals[PAGE_SIZE_CHANGED_SIGNAL], 0);
#line 958 "page.c"
	}
#line 292 "../src/page.vala"
	g_signal_emit (self, page_signals[PAGE_SCAN_LINE_CHANGED_SIGNAL], 0);
#line 293 "../src/page.vala"
	g_signal_emit (self, page_signals[PAGE_PIXELS_CHANGED_SIGNAL], 0);
#line 964 "page.c"
}


void
page_finish (Page* self)
{
	gboolean size_has_changed = FALSE;
	gboolean _tmp0_ = FALSE;
	gint _tmp1_;
	gboolean _tmp11_;
#line 296 "../src/page.vala"
	g_return_if_fail (self != NULL);
#line 298 "../src/page.vala"
	size_has_changed = FALSE;
#line 301 "../src/page.vala"
	_tmp1_ = self->priv->expected_rows;
#line 301 "../src/page.vala"
	if (_tmp1_ < 0) {
#line 983 "page.c"
		gint _tmp2_;
		gint _tmp3_;
#line 302 "../src/page.vala"
		_tmp2_ = self->priv->_scan_line;
#line 302 "../src/page.vala"
		_tmp3_ = self->priv->_scan_height;
#line 302 "../src/page.vala"
		_tmp0_ = _tmp2_ != _tmp3_;
#line 992 "page.c"
	} else {
#line 301 "../src/page.vala"
		_tmp0_ = FALSE;
#line 996 "page.c"
	}
#line 301 "../src/page.vala"
	if (_tmp0_) {
#line 1000 "page.c"
		gint rows = 0;
		gint _tmp4_;
		gint _tmp5_;
		gint _tmp6_;
		gint _tmp7_;
		gint _tmp8_;
		gint _tmp9_;
		gint _tmp10_;
#line 304 "../src/page.vala"
		_tmp4_ = self->priv->_scan_height;
#line 304 "../src/page.vala"
		rows = _tmp4_;
#line 305 "../src/page.vala"
		_tmp5_ = self->priv->_scan_line;
#line 305 "../src/page.vala"
		page_set_scan_height (self, _tmp5_);
#line 306 "../src/page.vala"
		_tmp6_ = self->priv->_scan_height;
#line 306 "../src/page.vala"
		_tmp7_ = self->priv->_rowstride;
#line 306 "../src/page.vala"
		_tmp8_ = _tmp6_ * _tmp7_;
#line 306 "../src/page.vala"
		self->priv->pixels = g_renew (guchar, self->priv->pixels, _tmp6_ * _tmp7_);
#line 306 "../src/page.vala"
		(_tmp8_ > self->priv->pixels_length1) ? memset (self->priv->pixels + self->priv->pixels_length1, 0, sizeof (guchar) * (_tmp8_ - self->priv->pixels_length1)) : NULL;
#line 306 "../src/page.vala"
		self->priv->pixels_length1 = _tmp8_;
#line 306 "../src/page.vala"
		self->priv->_pixels_size_ = _tmp8_;
#line 307 "../src/page.vala"
		_tmp9_ = rows;
#line 307 "../src/page.vala"
		_tmp10_ = self->priv->_scan_height;
#line 307 "../src/page.vala"
		g_debug ("page.vala:307: Trimming page from %d lines to %d lines", _tmp9_, _tmp10_);
#line 309 "../src/page.vala"
		size_has_changed = TRUE;
#line 1039 "page.c"
	}
#line 311 "../src/page.vala"
	page_set_is_scanning (self, FALSE);
#line 313 "../src/page.vala"
	_tmp11_ = size_has_changed;
#line 313 "../src/page.vala"
	if (_tmp11_) {
#line 314 "../src/page.vala"
		g_signal_emit (self, page_signals[PAGE_SIZE_CHANGED_SIGNAL], 0);
#line 1049 "page.c"
	}
#line 315 "../src/page.vala"
	g_signal_emit (self, page_signals[PAGE_SCAN_LINE_CHANGED_SIGNAL], 0);
#line 316 "../src/page.vala"
	g_signal_emit (self, page_signals[PAGE_SCAN_FINISHED_SIGNAL], 0);
#line 1055 "page.c"
}


void
page_rotate_left (Page* self)
{
	ScanDirection _tmp0_;
	ScanDirection _tmp1_;
#line 319 "../src/page.vala"
	g_return_if_fail (self != NULL);
#line 321 "../src/page.vala"
	_tmp0_ = page_get_scan_direction (self);
#line 321 "../src/page.vala"
	_tmp1_ = _tmp0_;
#line 321 "../src/page.vala"
	switch (_tmp1_) {
#line 321 "../src/page.vala"
		case SCAN_DIRECTION_TOP_TO_BOTTOM:
#line 1074 "page.c"
		{
#line 324 "../src/page.vala"
			page_set_scan_direction (self, SCAN_DIRECTION_LEFT_TO_RIGHT);
#line 325 "../src/page.vala"
			break;
#line 1080 "page.c"
		}
#line 321 "../src/page.vala"
		case SCAN_DIRECTION_LEFT_TO_RIGHT:
#line 1084 "page.c"
		{
#line 327 "../src/page.vala"
			page_set_scan_direction (self, SCAN_DIRECTION_BOTTOM_TO_TOP);
#line 328 "../src/page.vala"
			break;
#line 1090 "page.c"
		}
#line 321 "../src/page.vala"
		case SCAN_DIRECTION_BOTTOM_TO_TOP:
#line 1094 "page.c"
		{
#line 330 "../src/page.vala"
			page_set_scan_direction (self, SCAN_DIRECTION_RIGHT_TO_LEFT);
#line 331 "../src/page.vala"
			break;
#line 1100 "page.c"
		}
#line 321 "../src/page.vala"
		case SCAN_DIRECTION_RIGHT_TO_LEFT:
#line 1104 "page.c"
		{
#line 333 "../src/page.vala"
			page_set_scan_direction (self, SCAN_DIRECTION_TOP_TO_BOTTOM);
#line 334 "../src/page.vala"
			break;
#line 1110 "page.c"
		}
		default:
#line 321 "../src/page.vala"
		break;
#line 1115 "page.c"
	}
}


void
page_rotate_right (Page* self)
{
	ScanDirection _tmp0_;
	ScanDirection _tmp1_;
#line 338 "../src/page.vala"
	g_return_if_fail (self != NULL);
#line 340 "../src/page.vala"
	_tmp0_ = page_get_scan_direction (self);
#line 340 "../src/page.vala"
	_tmp1_ = _tmp0_;
#line 340 "../src/page.vala"
	switch (_tmp1_) {
#line 340 "../src/page.vala"
		case SCAN_DIRECTION_TOP_TO_BOTTOM:
#line 1135 "page.c"
		{
#line 343 "../src/page.vala"
			page_set_scan_direction (self, SCAN_DIRECTION_RIGHT_TO_LEFT);
#line 344 "../src/page.vala"
			break;
#line 1141 "page.c"
		}
#line 340 "../src/page.vala"
		case SCAN_DIRECTION_LEFT_TO_RIGHT:
#line 1145 "page.c"
		{
#line 346 "../src/page.vala"
			page_set_scan_direction (self, SCAN_DIRECTION_TOP_TO_BOTTOM);
#line 347 "../src/page.vala"
			break;
#line 1151 "page.c"
		}
#line 340 "../src/page.vala"
		case SCAN_DIRECTION_BOTTOM_TO_TOP:
#line 1155 "page.c"
		{
#line 349 "../src/page.vala"
			page_set_scan_direction (self, SCAN_DIRECTION_LEFT_TO_RIGHT);
#line 350 "../src/page.vala"
			break;
#line 1161 "page.c"
		}
#line 340 "../src/page.vala"
		case SCAN_DIRECTION_RIGHT_TO_LEFT:
#line 1165 "page.c"
		{
#line 352 "../src/page.vala"
			page_set_scan_direction (self, SCAN_DIRECTION_BOTTOM_TO_TOP);
#line 353 "../src/page.vala"
			break;
#line 1171 "page.c"
		}
		default:
#line 340 "../src/page.vala"
		break;
#line 1176 "page.c"
	}
}


void
page_set_no_crop (Page* self)
{
	gboolean _tmp0_;
#line 357 "../src/page.vala"
	g_return_if_fail (self != NULL);
#line 359 "../src/page.vala"
	_tmp0_ = self->priv->_has_crop;
#line 359 "../src/page.vala"
	if (!_tmp0_) {
#line 360 "../src/page.vala"
		return;
#line 1193 "page.c"
	}
#line 361 "../src/page.vala"
	page_set_has_crop (self, FALSE);
#line 362 "../src/page.vala"
	page_set_crop_name (self, NULL);
#line 363 "../src/page.vala"
	page_set_crop_x (self, 0);
#line 364 "../src/page.vala"
	page_set_crop_y (self, 0);
#line 365 "../src/page.vala"
	page_set_crop_width (self, 0);
#line 366 "../src/page.vala"
	page_set_crop_height (self, 0);
#line 367 "../src/page.vala"
	g_signal_emit (self, page_signals[PAGE_CROP_CHANGED_SIGNAL], 0);
#line 1209 "page.c"
}


void
page_set_custom_crop (Page* self,
                      gint width,
                      gint height)
{
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	gboolean _tmp2_ = FALSE;
	const gchar* _tmp3_;
#line 370 "../src/page.vala"
	g_return_if_fail (self != NULL);
#line 372 "../src/page.vala"
	g_return_if_fail (width >= 1);
#line 373 "../src/page.vala"
	g_return_if_fail (height >= 1);
#line 375 "../src/page.vala"
	_tmp3_ = self->priv->_crop_name;
#line 375 "../src/page.vala"
	if (_tmp3_ == NULL) {
#line 1232 "page.c"
		gboolean _tmp4_;
#line 375 "../src/page.vala"
		_tmp4_ = self->priv->_has_crop;
#line 375 "../src/page.vala"
		_tmp2_ = _tmp4_;
#line 1238 "page.c"
	} else {
#line 375 "../src/page.vala"
		_tmp2_ = FALSE;
#line 1242 "page.c"
	}
#line 375 "../src/page.vala"
	if (_tmp2_) {
#line 1246 "page.c"
		gint _tmp5_;
#line 375 "../src/page.vala"
		_tmp5_ = self->priv->_crop_width;
#line 375 "../src/page.vala"
		_tmp1_ = _tmp5_ == width;
#line 1252 "page.c"
	} else {
#line 375 "../src/page.vala"
		_tmp1_ = FALSE;
#line 1256 "page.c"
	}
#line 375 "../src/page.vala"
	if (_tmp1_) {
#line 1260 "page.c"
		gint _tmp6_;
#line 375 "../src/page.vala"
		_tmp6_ = self->priv->_crop_height;
#line 375 "../src/page.vala"
		_tmp0_ = _tmp6_ == height;
#line 1266 "page.c"
	} else {
#line 375 "../src/page.vala"
		_tmp0_ = FALSE;
#line 1270 "page.c"
	}
#line 375 "../src/page.vala"
	if (_tmp0_) {
#line 376 "../src/page.vala"
		return;
#line 1276 "page.c"
	}
#line 377 "../src/page.vala"
	page_set_crop_name (self, NULL);
#line 378 "../src/page.vala"
	page_set_has_crop (self, TRUE);
#line 380 "../src/page.vala"
	page_set_crop_width (self, width);
#line 381 "../src/page.vala"
	page_set_crop_height (self, height);
#line 394 "../src/page.vala"
	g_signal_emit (self, page_signals[PAGE_CROP_CHANGED_SIGNAL], 0);
#line 1288 "page.c"
}


void
page_set_named_crop (Page* self,
                     const gchar* name)
{
	gdouble w = 0.0;
	gdouble h = 0.0;
	const gchar* _tmp0_;
	GQuark _tmp2_ = 0U;
#line 400 "../src/page.vala"
	static GQuark _tmp1_label0 = 0;
#line 400 "../src/page.vala"
	static GQuark _tmp1_label1 = 0;
#line 400 "../src/page.vala"
	static GQuark _tmp1_label2 = 0;
#line 400 "../src/page.vala"
	static GQuark _tmp1_label3 = 0;
#line 400 "../src/page.vala"
	static GQuark _tmp1_label4 = 0;
#line 400 "../src/page.vala"
	static GQuark _tmp1_label5 = 0;
#line 400 "../src/page.vala"
	static GQuark _tmp1_label6 = 0;
#line 1314 "page.c"
	gint pw = 0;
	gint _tmp3_;
	gint _tmp4_;
	gint ph = 0;
	gint _tmp5_;
	gint _tmp6_;
	gint _tmp7_;
	gint _tmp8_;
	gdouble _tmp12_;
	gint _tmp13_;
	gdouble _tmp14_;
	gint _tmp15_;
	gint _tmp16_;
	gint _tmp17_;
	gint _tmp20_;
	gint _tmp21_;
#line 397 "../src/page.vala"
	g_return_if_fail (self != NULL);
#line 397 "../src/page.vala"
	g_return_if_fail (name != NULL);
#line 400 "../src/page.vala"
	_tmp0_ = name;
#line 400 "../src/page.vala"
	_tmp2_ = (NULL == _tmp0_) ? 0 : g_quark_from_string (_tmp0_);
#line 400 "../src/page.vala"
	if (_tmp2_ == ((0 != _tmp1_label0) ? _tmp1_label0 : (_tmp1_label0 = g_quark_from_static_string ("A3")))) {
#line 400 "../src/page.vala"
		switch (0) {
#line 1343 "page.c"
			default:
			{
#line 403 "../src/page.vala"
				w = 11.7;
#line 404 "../src/page.vala"
				h = 16.5;
#line 405 "../src/page.vala"
				break;
#line 1352 "page.c"
			}
		}
	} else if (_tmp2_ == ((0 != _tmp1_label1) ? _tmp1_label1 : (_tmp1_label1 = g_quark_from_static_string ("A4")))) {
#line 400 "../src/page.vala"
		switch (0) {
#line 1358 "page.c"
			default:
			{
#line 407 "../src/page.vala"
				w = 8.3;
#line 408 "../src/page.vala"
				h = 11.7;
#line 409 "../src/page.vala"
				break;
#line 1367 "page.c"
			}
		}
	} else if (_tmp2_ == ((0 != _tmp1_label2) ? _tmp1_label2 : (_tmp1_label2 = g_quark_from_static_string ("A5")))) {
#line 400 "../src/page.vala"
		switch (0) {
#line 1373 "page.c"
			default:
			{
#line 411 "../src/page.vala"
				w = 5.8;
#line 412 "../src/page.vala"
				h = 8.3;
#line 413 "../src/page.vala"
				break;
#line 1382 "page.c"
			}
		}
	} else if (_tmp2_ == ((0 != _tmp1_label3) ? _tmp1_label3 : (_tmp1_label3 = g_quark_from_static_string ("A6")))) {
#line 400 "../src/page.vala"
		switch (0) {
#line 1388 "page.c"
			default:
			{
#line 415 "../src/page.vala"
				w = 4.1;
#line 416 "../src/page.vala"
				h = 5.8;
#line 417 "../src/page.vala"
				break;
#line 1397 "page.c"
			}
		}
	} else if (_tmp2_ == ((0 != _tmp1_label4) ? _tmp1_label4 : (_tmp1_label4 = g_quark_from_static_string ("letter")))) {
#line 400 "../src/page.vala"
		switch (0) {
#line 1403 "page.c"
			default:
			{
#line 419 "../src/page.vala"
				w = 8.5;
#line 420 "../src/page.vala"
				h = (gdouble) 11;
#line 421 "../src/page.vala"
				break;
#line 1412 "page.c"
			}
		}
	} else if (_tmp2_ == ((0 != _tmp1_label5) ? _tmp1_label5 : (_tmp1_label5 = g_quark_from_static_string ("legal")))) {
#line 400 "../src/page.vala"
		switch (0) {
#line 1418 "page.c"
			default:
			{
#line 423 "../src/page.vala"
				w = 8.5;
#line 424 "../src/page.vala"
				h = (gdouble) 14;
#line 425 "../src/page.vala"
				break;
#line 1427 "page.c"
			}
		}
	} else if (_tmp2_ == ((0 != _tmp1_label6) ? _tmp1_label6 : (_tmp1_label6 = g_quark_from_static_string ("4x6")))) {
#line 400 "../src/page.vala"
		switch (0) {
#line 1433 "page.c"
			default:
			{
#line 427 "../src/page.vala"
				w = (gdouble) 4;
#line 428 "../src/page.vala"
				h = (gdouble) 6;
#line 429 "../src/page.vala"
				break;
#line 1442 "page.c"
			}
		}
	} else {
#line 400 "../src/page.vala"
		switch (0) {
#line 1448 "page.c"
			default:
			{
#line 431 "../src/page.vala"
				g_warning ("page.vala:431: Unknown paper size '%s'", name);
#line 432 "../src/page.vala"
				return;
#line 1455 "page.c"
			}
		}
	}
#line 435 "../src/page.vala"
	page_set_crop_name (self, name);
#line 436 "../src/page.vala"
	page_set_has_crop (self, TRUE);
#line 438 "../src/page.vala"
	_tmp3_ = page_get_width (self);
#line 438 "../src/page.vala"
	_tmp4_ = _tmp3_;
#line 438 "../src/page.vala"
	pw = _tmp4_;
#line 439 "../src/page.vala"
	_tmp5_ = page_get_height (self);
#line 439 "../src/page.vala"
	_tmp6_ = _tmp5_;
#line 439 "../src/page.vala"
	ph = _tmp6_;
#line 442 "../src/page.vala"
	_tmp7_ = pw;
#line 442 "../src/page.vala"
	_tmp8_ = ph;
#line 442 "../src/page.vala"
	if (_tmp7_ > _tmp8_) {
#line 1481 "page.c"
		gdouble t = 0.0;
		gdouble _tmp9_;
		gdouble _tmp10_;
		gdouble _tmp11_;
#line 444 "../src/page.vala"
		_tmp9_ = w;
#line 444 "../src/page.vala"
		t = _tmp9_;
#line 445 "../src/page.vala"
		_tmp10_ = h;
#line 445 "../src/page.vala"
		w = _tmp10_;
#line 446 "../src/page.vala"
		_tmp11_ = t;
#line 446 "../src/page.vala"
		h = _tmp11_;
#line 1498 "page.c"
	}
#line 450 "../src/page.vala"
	_tmp12_ = w;
#line 450 "../src/page.vala"
	_tmp13_ = self->priv->_dpi;
#line 450 "../src/page.vala"
	page_set_crop_width (self, (gint) ((_tmp12_ * _tmp13_) + 0.5));
#line 451 "../src/page.vala"
	_tmp14_ = h;
#line 451 "../src/page.vala"
	_tmp15_ = self->priv->_dpi;
#line 451 "../src/page.vala"
	page_set_crop_height (self, (gint) ((_tmp14_ * _tmp15_) + 0.5));
#line 453 "../src/page.vala"
	_tmp16_ = self->priv->_crop_width;
#line 453 "../src/page.vala"
	_tmp17_ = pw;
#line 453 "../src/page.vala"
	if (_tmp16_ < _tmp17_) {
#line 1518 "page.c"
		gint _tmp18_;
		gint _tmp19_;
#line 454 "../src/page.vala"
		_tmp18_ = pw;
#line 454 "../src/page.vala"
		_tmp19_ = self->priv->_crop_width;
#line 454 "../src/page.vala"
		page_set_crop_x (self, (_tmp18_ - _tmp19_) / 2);
#line 1527 "page.c"
	} else {
#line 456 "../src/page.vala"
		page_set_crop_x (self, 0);
#line 1531 "page.c"
	}
#line 457 "../src/page.vala"
	_tmp20_ = self->priv->_crop_height;
#line 457 "../src/page.vala"
	_tmp21_ = ph;
#line 457 "../src/page.vala"
	if (_tmp20_ < _tmp21_) {
#line 1539 "page.c"
		gint _tmp22_;
		gint _tmp23_;
#line 458 "../src/page.vala"
		_tmp22_ = ph;
#line 458 "../src/page.vala"
		_tmp23_ = self->priv->_crop_height;
#line 458 "../src/page.vala"
		page_set_crop_y (self, (_tmp22_ - _tmp23_) / 2);
#line 1548 "page.c"
	} else {
#line 460 "../src/page.vala"
		page_set_crop_y (self, 0);
#line 1552 "page.c"
	}
#line 461 "../src/page.vala"
	g_signal_emit (self, page_signals[PAGE_CROP_CHANGED_SIGNAL], 0);
#line 1556 "page.c"
}


void
page_move_crop (Page* self,
                gint x,
                gint y)
{
	gint _tmp0_;
	gint _tmp1_;
	gint _tmp2_;
	gint _tmp3_;
#line 464 "../src/page.vala"
	g_return_if_fail (self != NULL);
#line 466 "../src/page.vala"
	g_return_if_fail (x >= 0);
#line 467 "../src/page.vala"
	g_return_if_fail (y >= 0);
#line 468 "../src/page.vala"
	_tmp0_ = page_get_width (self);
#line 468 "../src/page.vala"
	_tmp1_ = _tmp0_;
#line 468 "../src/page.vala"
	g_return_if_fail (x < _tmp1_);
#line 469 "../src/page.vala"
	_tmp2_ = page_get_height (self);
#line 469 "../src/page.vala"
	_tmp3_ = _tmp2_;
#line 469 "../src/page.vala"
	g_return_if_fail (y < _tmp3_);
#line 471 "../src/page.vala"
	page_set_crop_x (self, x);
#line 472 "../src/page.vala"
	page_set_crop_y (self, y);
#line 473 "../src/page.vala"
	g_signal_emit (self, page_signals[PAGE_CROP_CHANGED_SIGNAL], 0);
#line 1593 "page.c"
}


void
page_rotate_crop (Page* self)
{
	gboolean _tmp0_;
	gint t = 0;
	gint _tmp1_;
	gint _tmp2_;
	gint _tmp3_;
	const gchar* _tmp4_;
#line 476 "../src/page.vala"
	g_return_if_fail (self != NULL);
#line 478 "../src/page.vala"
	_tmp0_ = self->priv->_has_crop;
#line 478 "../src/page.vala"
	if (!_tmp0_) {
#line 479 "../src/page.vala"
		return;
#line 1614 "page.c"
	}
#line 481 "../src/page.vala"
	_tmp1_ = self->priv->_crop_width;
#line 481 "../src/page.vala"
	t = _tmp1_;
#line 482 "../src/page.vala"
	_tmp2_ = self->priv->_crop_height;
#line 482 "../src/page.vala"
	page_set_crop_width (self, _tmp2_);
#line 483 "../src/page.vala"
	_tmp3_ = t;
#line 483 "../src/page.vala"
	page_set_crop_height (self, _tmp3_);
#line 486 "../src/page.vala"
	_tmp4_ = self->priv->_crop_name;
#line 486 "../src/page.vala"
	if (_tmp4_ == NULL) {
#line 1632 "page.c"
		gint w = 0;
		gint _tmp5_;
		gint _tmp6_;
		gint h = 0;
		gint _tmp7_;
		gint _tmp8_;
		gint _tmp9_;
		gint _tmp10_;
		gint _tmp11_;
		gint _tmp14_;
		gint _tmp16_;
		gint _tmp17_;
		gint _tmp18_;
		gint _tmp21_;
#line 488 "../src/page.vala"
		_tmp5_ = page_get_width (self);
#line 488 "../src/page.vala"
		_tmp6_ = _tmp5_;
#line 488 "../src/page.vala"
		w = _tmp6_;
#line 489 "../src/page.vala"
		_tmp7_ = page_get_height (self);
#line 489 "../src/page.vala"
		_tmp8_ = _tmp7_;
#line 489 "../src/page.vala"
		h = _tmp8_;
#line 491 "../src/page.vala"
		_tmp9_ = self->priv->_crop_x;
#line 491 "../src/page.vala"
		_tmp10_ = self->priv->_crop_width;
#line 491 "../src/page.vala"
		_tmp11_ = w;
#line 491 "../src/page.vala"
		if ((_tmp9_ + _tmp10_) > _tmp11_) {
#line 1667 "page.c"
			gint _tmp12_;
			gint _tmp13_;
#line 492 "../src/page.vala"
			_tmp12_ = w;
#line 492 "../src/page.vala"
			_tmp13_ = self->priv->_crop_width;
#line 492 "../src/page.vala"
			page_set_crop_x (self, _tmp12_ - _tmp13_);
#line 1676 "page.c"
		}
#line 493 "../src/page.vala"
		_tmp14_ = self->priv->_crop_x;
#line 493 "../src/page.vala"
		if (_tmp14_ < 0) {
#line 1682 "page.c"
			gint _tmp15_;
#line 495 "../src/page.vala"
			page_set_crop_x (self, 0);
#line 496 "../src/page.vala"
			_tmp15_ = w;
#line 496 "../src/page.vala"
			page_set_crop_width (self, _tmp15_);
#line 1690 "page.c"
		}
#line 498 "../src/page.vala"
		_tmp16_ = self->priv->_crop_y;
#line 498 "../src/page.vala"
		_tmp17_ = self->priv->_crop_height;
#line 498 "../src/page.vala"
		_tmp18_ = h;
#line 498 "../src/page.vala"
		if ((_tmp16_ + _tmp17_) > _tmp18_) {
#line 1700 "page.c"
			gint _tmp19_;
			gint _tmp20_;
#line 499 "../src/page.vala"
			_tmp19_ = h;
#line 499 "../src/page.vala"
			_tmp20_ = self->priv->_crop_height;
#line 499 "../src/page.vala"
			page_set_crop_y (self, _tmp19_ - _tmp20_);
#line 1709 "page.c"
		}
#line 500 "../src/page.vala"
		_tmp21_ = self->priv->_crop_y;
#line 500 "../src/page.vala"
		if (_tmp21_ < 0) {
#line 1715 "page.c"
			gint _tmp22_;
#line 502 "../src/page.vala"
			page_set_crop_y (self, 0);
#line 503 "../src/page.vala"
			_tmp22_ = h;
#line 503 "../src/page.vala"
			page_set_crop_height (self, _tmp22_);
#line 1723 "page.c"
		}
	}
#line 507 "../src/page.vala"
	g_signal_emit (self, page_signals[PAGE_CROP_CHANGED_SIGNAL], 0);
#line 1728 "page.c"
}


guchar*
page_get_pixels (Page* self,
                 int* result_length1)
{
	guchar* result = NULL;
	guchar* _tmp0_;
	gint _tmp0__length1;
	guchar* _tmp1_;
	gint _tmp1__length1;
#line 510 "../src/page.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 512 "../src/page.vala"
	_tmp0_ = self->priv->pixels;
#line 512 "../src/page.vala"
	_tmp0__length1 = self->priv->pixels_length1;
#line 512 "../src/page.vala"
	_tmp1_ = _tmp0_;
#line 512 "../src/page.vala"
	_tmp1__length1 = _tmp0__length1;
#line 512 "../src/page.vala"
	if (result_length1) {
#line 512 "../src/page.vala"
		*result_length1 = _tmp1__length1;
#line 1755 "page.c"
	}
#line 512 "../src/page.vala"
	result = _tmp1_;
#line 512 "../src/page.vala"
	return result;
#line 1761 "page.c"
}


static guchar
page_get_sample (Page* self,
                 guchar* pixels,
                 int pixels_length1,
                 gint offset,
                 gint x,
                 gint depth,
                 gint n_channels,
                 gint channel)
{
	guchar result = '\0';
#line 516 "../src/page.vala"
	g_return_val_if_fail (self != NULL, '\0');
#line 519 "../src/page.vala"
	result = (guchar) 0xFF;
#line 519 "../src/page.vala"
	return result;
#line 1782 "page.c"
}


static void
page_get_pixel (Page* self,
                gint x,
                gint y,
                guchar* pixel,
                int pixel_length1,
                gint offset)
{
	ScanDirection _tmp0_;
	ScanDirection _tmp1_;
	gint line_offset = 0;
	gint _tmp8_;
	gboolean _tmp9_ = FALSE;
	gint _tmp10_;
	guchar* _tmp61_;
	gint _tmp61__length1;
	gint _tmp62_;
	gint _tmp63_;
	gint _tmp64_;
	guchar _tmp65_;
	guchar* _tmp66_;
	gint _tmp66__length1;
	gint _tmp67_;
	gint _tmp68_;
	gint _tmp69_;
	guchar _tmp70_;
	guchar* _tmp71_;
	gint _tmp71__length1;
	gint _tmp72_;
	gint _tmp73_;
	gint _tmp74_;
	guchar _tmp75_;
#line 523 "../src/page.vala"
	g_return_if_fail (self != NULL);
#line 525 "../src/page.vala"
	_tmp0_ = page_get_scan_direction (self);
#line 525 "../src/page.vala"
	_tmp1_ = _tmp0_;
#line 525 "../src/page.vala"
	switch (_tmp1_) {
#line 525 "../src/page.vala"
		case SCAN_DIRECTION_TOP_TO_BOTTOM:
#line 1828 "page.c"
		{
#line 528 "../src/page.vala"
			break;
#line 1832 "page.c"
		}
#line 525 "../src/page.vala"
		case SCAN_DIRECTION_BOTTOM_TO_TOP:
#line 1836 "page.c"
		{
			gint _tmp2_;
			gint _tmp3_;
#line 530 "../src/page.vala"
			_tmp2_ = self->priv->_scan_width;
#line 530 "../src/page.vala"
			x = (_tmp2_ - x) - 1;
#line 531 "../src/page.vala"
			_tmp3_ = self->priv->_scan_height;
#line 531 "../src/page.vala"
			y = (_tmp3_ - y) - 1;
#line 532 "../src/page.vala"
			break;
#line 1850 "page.c"
		}
#line 525 "../src/page.vala"
		case SCAN_DIRECTION_LEFT_TO_RIGHT:
#line 1854 "page.c"
		{
			gint t = 0;
			gint _tmp4_;
			gint _tmp5_;
#line 534 "../src/page.vala"
			t = x;
#line 535 "../src/page.vala"
			_tmp4_ = self->priv->_scan_width;
#line 535 "../src/page.vala"
			x = (_tmp4_ - y) - 1;
#line 536 "../src/page.vala"
			_tmp5_ = t;
#line 536 "../src/page.vala"
			y = _tmp5_;
#line 537 "../src/page.vala"
			break;
#line 1871 "page.c"
		}
#line 525 "../src/page.vala"
		case SCAN_DIRECTION_RIGHT_TO_LEFT:
#line 1875 "page.c"
		{
			gint t = 0;
			gint _tmp6_;
			gint _tmp7_;
#line 539 "../src/page.vala"
			t = x;
#line 540 "../src/page.vala"
			x = y;
#line 541 "../src/page.vala"
			_tmp6_ = self->priv->_scan_height;
#line 541 "../src/page.vala"
			_tmp7_ = t;
#line 541 "../src/page.vala"
			y = (_tmp6_ - _tmp7_) - 1;
#line 542 "../src/page.vala"
			break;
#line 1892 "page.c"
		}
		default:
#line 525 "../src/page.vala"
		break;
#line 1897 "page.c"
	}
#line 545 "../src/page.vala"
	_tmp8_ = self->priv->_rowstride;
#line 545 "../src/page.vala"
	line_offset = _tmp8_ * y;
#line 548 "../src/page.vala"
	_tmp10_ = self->priv->_depth;
#line 548 "../src/page.vala"
	if (_tmp10_ == 8) {
#line 1907 "page.c"
		gint _tmp11_;
#line 548 "../src/page.vala"
		_tmp11_ = self->priv->_n_channels;
#line 548 "../src/page.vala"
		_tmp9_ = _tmp11_ == 3;
#line 1913 "page.c"
	} else {
#line 548 "../src/page.vala"
		_tmp9_ = FALSE;
#line 1917 "page.c"
	}
#line 548 "../src/page.vala"
	if (_tmp9_) {
#line 1921 "page.c"
		gint o = 0;
		gint _tmp12_;
		gint _tmp13_;
		guchar* _tmp14_;
		gint _tmp14__length1;
		gint _tmp15_;
		guchar _tmp16_;
		guchar _tmp17_;
		guchar* _tmp18_;
		gint _tmp18__length1;
		gint _tmp19_;
		guchar _tmp20_;
		guchar _tmp21_;
		guchar* _tmp22_;
		gint _tmp22__length1;
		gint _tmp23_;
		guchar _tmp24_;
		guchar _tmp25_;
#line 550 "../src/page.vala"
		_tmp12_ = line_offset;
#line 550 "../src/page.vala"
		_tmp13_ = self->priv->_n_channels;
#line 550 "../src/page.vala"
		o = _tmp12_ + (x * _tmp13_);
#line 551 "../src/page.vala"
		_tmp14_ = self->priv->pixels;
#line 551 "../src/page.vala"
		_tmp14__length1 = self->priv->pixels_length1;
#line 551 "../src/page.vala"
		_tmp15_ = o;
#line 551 "../src/page.vala"
		_tmp16_ = _tmp14_[_tmp15_];
#line 551 "../src/page.vala"
		pixel[offset + 0] = _tmp16_;
#line 551 "../src/page.vala"
		_tmp17_ = pixel[offset + 0];
#line 552 "../src/page.vala"
		_tmp18_ = self->priv->pixels;
#line 552 "../src/page.vala"
		_tmp18__length1 = self->priv->pixels_length1;
#line 552 "../src/page.vala"
		_tmp19_ = o;
#line 552 "../src/page.vala"
		_tmp20_ = _tmp18_[_tmp19_ + 1];
#line 552 "../src/page.vala"
		pixel[offset + 1] = _tmp20_;
#line 552 "../src/page.vala"
		_tmp21_ = pixel[offset + 1];
#line 553 "../src/page.vala"
		_tmp22_ = self->priv->pixels;
#line 553 "../src/page.vala"
		_tmp22__length1 = self->priv->pixels_length1;
#line 553 "../src/page.vala"
		_tmp23_ = o;
#line 553 "../src/page.vala"
		_tmp24_ = _tmp22_[_tmp23_ + 2];
#line 553 "../src/page.vala"
		pixel[offset + 2] = _tmp24_;
#line 553 "../src/page.vala"
		_tmp25_ = pixel[offset + 2];
#line 554 "../src/page.vala"
		return;
#line 1984 "page.c"
	} else {
		gboolean _tmp26_ = FALSE;
		gint _tmp27_;
#line 556 "../src/page.vala"
		_tmp27_ = self->priv->_depth;
#line 556 "../src/page.vala"
		if (_tmp27_ == 8) {
#line 1992 "page.c"
			gint _tmp28_;
#line 556 "../src/page.vala"
			_tmp28_ = self->priv->_n_channels;
#line 556 "../src/page.vala"
			_tmp26_ = _tmp28_ == 1;
#line 1998 "page.c"
		} else {
#line 556 "../src/page.vala"
			_tmp26_ = FALSE;
#line 2002 "page.c"
		}
#line 556 "../src/page.vala"
		if (_tmp26_) {
#line 2006 "page.c"
			guchar p = '\0';
			guchar* _tmp29_;
			gint _tmp29__length1;
			gint _tmp30_;
			guchar _tmp31_;
			guchar _tmp32_;
			guchar _tmp33_;
			guchar _tmp34_;
			guchar _tmp35_;
#line 558 "../src/page.vala"
			_tmp29_ = self->priv->pixels;
#line 558 "../src/page.vala"
			_tmp29__length1 = self->priv->pixels_length1;
#line 558 "../src/page.vala"
			_tmp30_ = line_offset;
#line 558 "../src/page.vala"
			_tmp31_ = _tmp29_[_tmp30_ + x];
#line 558 "../src/page.vala"
			p = _tmp31_;
#line 559 "../src/page.vala"
			_tmp32_ = p;
#line 559 "../src/page.vala"
			pixel[offset + 2] = _tmp32_;
#line 559 "../src/page.vala"
			_tmp33_ = pixel[offset + 2];
#line 559 "../src/page.vala"
			pixel[offset + 1] = _tmp33_;
#line 559 "../src/page.vala"
			_tmp34_ = pixel[offset + 1];
#line 559 "../src/page.vala"
			pixel[offset + 0] = _tmp34_;
#line 559 "../src/page.vala"
			_tmp35_ = pixel[offset + 0];
#line 560 "../src/page.vala"
			return;
#line 2042 "page.c"
		} else {
			gboolean _tmp36_ = FALSE;
			gint _tmp37_;
#line 564 "../src/page.vala"
			_tmp37_ = self->priv->_depth;
#line 564 "../src/page.vala"
			if (_tmp37_ == 1) {
#line 2050 "page.c"
				gint _tmp38_;
#line 564 "../src/page.vala"
				_tmp38_ = self->priv->_n_channels;
#line 564 "../src/page.vala"
				_tmp36_ = _tmp38_ == 1;
#line 2056 "page.c"
			} else {
#line 564 "../src/page.vala"
				_tmp36_ = FALSE;
#line 2060 "page.c"
			}
#line 564 "../src/page.vala"
			if (_tmp36_) {
#line 2064 "page.c"
				guchar p = '\0';
				guchar* _tmp39_;
				gint _tmp39__length1;
				gint _tmp40_;
				guchar _tmp41_;
				gint _tmp42_ = 0;
				guchar _tmp43_;
				guchar _tmp44_;
				guchar _tmp45_;
				guchar _tmp46_;
#line 566 "../src/page.vala"
				_tmp39_ = self->priv->pixels;
#line 566 "../src/page.vala"
				_tmp39__length1 = self->priv->pixels_length1;
#line 566 "../src/page.vala"
				_tmp40_ = line_offset;
#line 566 "../src/page.vala"
				_tmp41_ = _tmp39_[_tmp40_ + (x / 8)];
#line 566 "../src/page.vala"
				p = _tmp41_;
#line 567 "../src/page.vala"
				_tmp43_ = p;
#line 567 "../src/page.vala"
				if (((gint) (_tmp43_ & (0x80 >> (x % 8)))) != 0) {
#line 567 "../src/page.vala"
					_tmp42_ = 0x00;
#line 2091 "page.c"
				} else {
#line 567 "../src/page.vala"
					_tmp42_ = 0xFF;
#line 2095 "page.c"
				}
#line 567 "../src/page.vala"
				pixel[offset + 2] = (guchar) _tmp42_;
#line 567 "../src/page.vala"
				_tmp44_ = pixel[offset + 2];
#line 567 "../src/page.vala"
				pixel[offset + 1] = _tmp44_;
#line 567 "../src/page.vala"
				_tmp45_ = pixel[offset + 1];
#line 567 "../src/page.vala"
				pixel[offset + 0] = _tmp45_;
#line 567 "../src/page.vala"
				_tmp46_ = pixel[offset + 0];
#line 568 "../src/page.vala"
				return;
#line 2111 "page.c"
			} else {
				gboolean _tmp47_ = FALSE;
				gint _tmp48_;
#line 572 "../src/page.vala"
				_tmp48_ = self->priv->_depth;
#line 572 "../src/page.vala"
				if (_tmp48_ == 2) {
#line 2119 "page.c"
					gint _tmp49_;
#line 572 "../src/page.vala"
					_tmp49_ = self->priv->_n_channels;
#line 572 "../src/page.vala"
					_tmp47_ = _tmp49_ == 1;
#line 2125 "page.c"
				} else {
#line 572 "../src/page.vala"
					_tmp47_ = FALSE;
#line 2129 "page.c"
				}
#line 572 "../src/page.vala"
				if (_tmp47_) {
#line 2133 "page.c"
					gint block_shift[4] = {0};
					gint _tmp50_[4] = {0};
					guchar p = '\0';
					guchar* _tmp51_;
					gint _tmp51__length1;
					gint _tmp52_;
					guchar _tmp53_;
					gint sample = 0;
					guchar _tmp54_;
					gint _tmp55_;
					gint _tmp56_;
					gint _tmp57_;
					guchar _tmp58_;
					guchar _tmp59_;
					guchar _tmp60_;
#line 574 "../src/page.vala"
					_tmp50_[0] = 6;
#line 574 "../src/page.vala"
					_tmp50_[1] = 4;
#line 574 "../src/page.vala"
					_tmp50_[2] = 2;
#line 574 "../src/page.vala"
					_tmp50_[3] = 0;
#line 574 "../src/page.vala"
					memcpy (block_shift, _tmp50_, 4 * sizeof (gint));
#line 576 "../src/page.vala"
					_tmp51_ = self->priv->pixels;
#line 576 "../src/page.vala"
					_tmp51__length1 = self->priv->pixels_length1;
#line 576 "../src/page.vala"
					_tmp52_ = line_offset;
#line 576 "../src/page.vala"
					_tmp53_ = _tmp51_[_tmp52_ + (x / 4)];
#line 576 "../src/page.vala"
					p = _tmp53_;
#line 577 "../src/page.vala"
					_tmp54_ = p;
#line 577 "../src/page.vala"
					_tmp55_ = block_shift[x % 4];
#line 577 "../src/page.vala"
					sample = (_tmp54_ >> _tmp55_) & 0x3;
#line 578 "../src/page.vala"
					_tmp56_ = sample;
#line 578 "../src/page.vala"
					sample = (_tmp56_ * 255) / 3;
#line 580 "../src/page.vala"
					_tmp57_ = sample;
#line 580 "../src/page.vala"
					pixel[offset + 2] = (guchar) _tmp57_;
#line 580 "../src/page.vala"
					_tmp58_ = pixel[offset + 2];
#line 580 "../src/page.vala"
					pixel[offset + 1] = _tmp58_;
#line 580 "../src/page.vala"
					_tmp59_ = pixel[offset + 1];
#line 580 "../src/page.vala"
					pixel[offset + 0] = _tmp59_;
#line 580 "../src/page.vala"
					_tmp60_ = pixel[offset + 0];
#line 581 "../src/page.vala"
					return;
#line 2195 "page.c"
				}
			}
		}
	}
#line 585 "../src/page.vala"
	_tmp61_ = self->priv->pixels;
#line 585 "../src/page.vala"
	_tmp61__length1 = self->priv->pixels_length1;
#line 585 "../src/page.vala"
	_tmp62_ = line_offset;
#line 585 "../src/page.vala"
	_tmp63_ = self->priv->_depth;
#line 585 "../src/page.vala"
	_tmp64_ = self->priv->_n_channels;
#line 585 "../src/page.vala"
	pixel[offset + 0] = page_get_sample (self, _tmp61_, _tmp61__length1, _tmp62_, x, _tmp63_, _tmp64_, 0);
#line 585 "../src/page.vala"
	_tmp65_ = pixel[offset + 0];
#line 586 "../src/page.vala"
	_tmp66_ = self->priv->pixels;
#line 586 "../src/page.vala"
	_tmp66__length1 = self->priv->pixels_length1;
#line 586 "../src/page.vala"
	_tmp67_ = line_offset;
#line 586 "../src/page.vala"
	_tmp68_ = self->priv->_depth;
#line 586 "../src/page.vala"
	_tmp69_ = self->priv->_n_channels;
#line 586 "../src/page.vala"
	pixel[offset + 1] = page_get_sample (self, _tmp66_, _tmp66__length1, _tmp67_, x, _tmp68_, _tmp69_, 1);
#line 586 "../src/page.vala"
	_tmp70_ = pixel[offset + 1];
#line 587 "../src/page.vala"
	_tmp71_ = self->priv->pixels;
#line 587 "../src/page.vala"
	_tmp71__length1 = self->priv->pixels_length1;
#line 587 "../src/page.vala"
	_tmp72_ = line_offset;
#line 587 "../src/page.vala"
	_tmp73_ = self->priv->_depth;
#line 587 "../src/page.vala"
	_tmp74_ = self->priv->_n_channels;
#line 587 "../src/page.vala"
	pixel[offset + 2] = page_get_sample (self, _tmp71_, _tmp71__length1, _tmp72_, x, _tmp73_, _tmp74_, 2);
#line 587 "../src/page.vala"
	_tmp75_ = pixel[offset + 2];
#line 2242 "page.c"
}


GdkPixbuf*
page_get_image (Page* self,
                gboolean apply_crop)
{
	GdkPixbuf* result = NULL;
	gint l = 0;
	gint r = 0;
	gint t = 0;
	gint b = 0;
	gboolean _tmp0_ = FALSE;
	GdkPixbuf* image = NULL;
	gint _tmp24_;
	gint _tmp25_;
	gint _tmp26_;
	gint _tmp27_;
	GdkPixbuf* _tmp28_;
	guint8* image_pixels = NULL;
	GdkPixbuf* _tmp29_;
	guint8* _tmp30_;
	gint image_pixels_length1;
	gint _image_pixels_size_;
#line 590 "../src/page.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 593 "../src/page.vala"
	if (apply_crop) {
#line 2271 "page.c"
		gboolean _tmp1_;
#line 593 "../src/page.vala"
		_tmp1_ = self->priv->_has_crop;
#line 593 "../src/page.vala"
		_tmp0_ = _tmp1_;
#line 2277 "page.c"
	} else {
#line 593 "../src/page.vala"
		_tmp0_ = FALSE;
#line 2281 "page.c"
	}
#line 593 "../src/page.vala"
	if (_tmp0_) {
#line 2285 "page.c"
		gint _tmp2_;
		gint _tmp3_;
		gint _tmp4_;
		gint _tmp5_;
		gint _tmp6_;
		gint _tmp7_;
		gint _tmp8_;
		gint _tmp9_;
		gint _tmp10_;
		gint _tmp11_;
		gint _tmp14_;
		gint _tmp15_;
		gint _tmp16_;
		gint _tmp17_;
#line 595 "../src/page.vala"
		_tmp2_ = self->priv->_crop_x;
#line 595 "../src/page.vala"
		l = _tmp2_;
#line 596 "../src/page.vala"
		_tmp3_ = l;
#line 596 "../src/page.vala"
		_tmp4_ = self->priv->_crop_width;
#line 596 "../src/page.vala"
		r = _tmp3_ + _tmp4_;
#line 597 "../src/page.vala"
		_tmp5_ = self->priv->_crop_y;
#line 597 "../src/page.vala"
		t = _tmp5_;
#line 598 "../src/page.vala"
		_tmp6_ = t;
#line 598 "../src/page.vala"
		_tmp7_ = self->priv->_crop_height;
#line 598 "../src/page.vala"
		b = _tmp6_ + _tmp7_;
#line 600 "../src/page.vala"
		_tmp8_ = l;
#line 600 "../src/page.vala"
		if (_tmp8_ < 0) {
#line 601 "../src/page.vala"
			l = 0;
#line 2326 "page.c"
		}
#line 602 "../src/page.vala"
		_tmp9_ = r;
#line 602 "../src/page.vala"
		_tmp10_ = page_get_width (self);
#line 602 "../src/page.vala"
		_tmp11_ = _tmp10_;
#line 602 "../src/page.vala"
		if (_tmp9_ > _tmp11_) {
#line 2336 "page.c"
			gint _tmp12_;
			gint _tmp13_;
#line 603 "../src/page.vala"
			_tmp12_ = page_get_width (self);
#line 603 "../src/page.vala"
			_tmp13_ = _tmp12_;
#line 603 "../src/page.vala"
			r = _tmp13_;
#line 2345 "page.c"
		}
#line 604 "../src/page.vala"
		_tmp14_ = t;
#line 604 "../src/page.vala"
		if (_tmp14_ < 0) {
#line 605 "../src/page.vala"
			t = 0;
#line 2353 "page.c"
		}
#line 606 "../src/page.vala"
		_tmp15_ = b;
#line 606 "../src/page.vala"
		_tmp16_ = page_get_height (self);
#line 606 "../src/page.vala"
		_tmp17_ = _tmp16_;
#line 606 "../src/page.vala"
		if (_tmp15_ > _tmp17_) {
#line 2363 "page.c"
			gint _tmp18_;
			gint _tmp19_;
#line 607 "../src/page.vala"
			_tmp18_ = page_get_height (self);
#line 607 "../src/page.vala"
			_tmp19_ = _tmp18_;
#line 607 "../src/page.vala"
			b = _tmp19_;
#line 2372 "page.c"
		}
	} else {
		gint _tmp20_;
		gint _tmp21_;
		gint _tmp22_;
		gint _tmp23_;
#line 611 "../src/page.vala"
		l = 0;
#line 612 "../src/page.vala"
		_tmp20_ = page_get_width (self);
#line 612 "../src/page.vala"
		_tmp21_ = _tmp20_;
#line 612 "../src/page.vala"
		r = _tmp21_;
#line 613 "../src/page.vala"
		t = 0;
#line 614 "../src/page.vala"
		_tmp22_ = page_get_height (self);
#line 614 "../src/page.vala"
		_tmp23_ = _tmp22_;
#line 614 "../src/page.vala"
		b = _tmp23_;
#line 2395 "page.c"
	}
#line 617 "../src/page.vala"
	_tmp24_ = r;
#line 617 "../src/page.vala"
	_tmp25_ = l;
#line 617 "../src/page.vala"
	_tmp26_ = b;
#line 617 "../src/page.vala"
	_tmp27_ = t;
#line 617 "../src/page.vala"
	_tmp28_ = gdk_pixbuf_new (GDK_COLORSPACE_RGB, FALSE, 8, _tmp24_ - _tmp25_, _tmp26_ - _tmp27_);
#line 617 "../src/page.vala"
	image = _tmp28_;
#line 618 "../src/page.vala"
	_tmp29_ = image;
#line 618 "../src/page.vala"
	_tmp30_ = gdk_pixbuf_get_pixels (_tmp29_);
#line 618 "../src/page.vala"
	image_pixels = _tmp30_;
#line 618 "../src/page.vala"
	image_pixels_length1 = -1;
#line 618 "../src/page.vala"
	_image_pixels_size_ = image_pixels_length1;
#line 2419 "page.c"
	{
		gint y = 0;
		gint _tmp31_;
#line 619 "../src/page.vala"
		_tmp31_ = t;
#line 619 "../src/page.vala"
		y = _tmp31_;
#line 2427 "page.c"
		{
			gboolean _tmp32_ = FALSE;
#line 619 "../src/page.vala"
			_tmp32_ = TRUE;
#line 619 "../src/page.vala"
			while (TRUE) {
#line 2434 "page.c"
				gint _tmp34_;
				gint _tmp35_;
				gint offset = 0;
				GdkPixbuf* _tmp36_;
				gint _tmp37_;
				gint _tmp38_;
#line 619 "../src/page.vala"
				if (!_tmp32_) {
#line 2443 "page.c"
					gint _tmp33_;
#line 619 "../src/page.vala"
					_tmp33_ = y;
#line 619 "../src/page.vala"
					y = _tmp33_ + 1;
#line 2449 "page.c"
				}
#line 619 "../src/page.vala"
				_tmp32_ = FALSE;
#line 619 "../src/page.vala"
				_tmp34_ = y;
#line 619 "../src/page.vala"
				_tmp35_ = b;
#line 619 "../src/page.vala"
				if (!(_tmp34_ < _tmp35_)) {
#line 619 "../src/page.vala"
					break;
#line 2461 "page.c"
				}
#line 621 "../src/page.vala"
				_tmp36_ = image;
#line 621 "../src/page.vala"
				_tmp37_ = y;
#line 621 "../src/page.vala"
				_tmp38_ = t;
#line 621 "../src/page.vala"
				offset = gdk_pixbuf_get_rowstride (_tmp36_) * (_tmp37_ - _tmp38_);
#line 2471 "page.c"
				{
					gint x = 0;
					gint _tmp39_;
#line 622 "../src/page.vala"
					_tmp39_ = l;
#line 622 "../src/page.vala"
					x = _tmp39_;
#line 2479 "page.c"
					{
						gboolean _tmp40_ = FALSE;
#line 622 "../src/page.vala"
						_tmp40_ = TRUE;
#line 622 "../src/page.vala"
						while (TRUE) {
#line 2486 "page.c"
							gint _tmp42_;
							gint _tmp43_;
							gint _tmp44_;
							gint _tmp45_;
							guint8* _tmp46_;
							gint _tmp46__length1;
							gint _tmp47_;
							gint _tmp48_;
							gint _tmp49_;
#line 622 "../src/page.vala"
							if (!_tmp40_) {
#line 2498 "page.c"
								gint _tmp41_;
#line 622 "../src/page.vala"
								_tmp41_ = x;
#line 622 "../src/page.vala"
								x = _tmp41_ + 1;
#line 2504 "page.c"
							}
#line 622 "../src/page.vala"
							_tmp40_ = FALSE;
#line 622 "../src/page.vala"
							_tmp42_ = x;
#line 622 "../src/page.vala"
							_tmp43_ = r;
#line 622 "../src/page.vala"
							if (!(_tmp42_ < _tmp43_)) {
#line 622 "../src/page.vala"
								break;
#line 2516 "page.c"
							}
#line 623 "../src/page.vala"
							_tmp44_ = x;
#line 623 "../src/page.vala"
							_tmp45_ = y;
#line 623 "../src/page.vala"
							_tmp46_ = image_pixels;
#line 623 "../src/page.vala"
							_tmp46__length1 = image_pixels_length1;
#line 623 "../src/page.vala"
							_tmp47_ = offset;
#line 623 "../src/page.vala"
							_tmp48_ = x;
#line 623 "../src/page.vala"
							_tmp49_ = l;
#line 623 "../src/page.vala"
							page_get_pixel (self, _tmp44_, _tmp45_, _tmp46_, _tmp46__length1, _tmp47_ + ((_tmp48_ - _tmp49_) * 3));
#line 2534 "page.c"
						}
					}
				}
			}
		}
	}
#line 626 "../src/page.vala"
	result = image;
#line 626 "../src/page.vala"
	return result;
#line 2545 "page.c"
}


static gchar*
string_to_utf8 (const gchar* self,
                int* result_length1)
{
	gchar* result = NULL;
	gint string_length = 0;
	gint _tmp0_;
	gint _tmp1_;
	gchar* _result_ = NULL;
	gint _tmp2_;
	gchar* _tmp3_;
	gint _result__length1;
	gint __result__size_;
	gint _tmp4_;
	gchar* _tmp5_;
	gint _tmp5__length1;
	gint _tmp6_;
	gchar* _tmp7_;
	gint _tmp7__length1;
#line 1505 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1506 "glib-2.0.vapi"
	_tmp0_ = strlen (self);
#line 1506 "glib-2.0.vapi"
	_tmp1_ = _tmp0_;
#line 1506 "glib-2.0.vapi"
	string_length = _tmp1_;
#line 1507 "glib-2.0.vapi"
	_tmp2_ = string_length;
#line 1507 "glib-2.0.vapi"
	_tmp3_ = g_new0 (gchar, _tmp2_ + 1);
#line 1507 "glib-2.0.vapi"
	_result_ = _tmp3_;
#line 1507 "glib-2.0.vapi"
	_result__length1 = _tmp2_ + 1;
#line 1507 "glib-2.0.vapi"
	__result__size_ = _result__length1;
#line 1508 "glib-2.0.vapi"
	_tmp4_ = _result__length1;
#line 1508 "glib-2.0.vapi"
	_result__length1 = _tmp4_ - 1;
#line 1509 "glib-2.0.vapi"
	_tmp5_ = _result_;
#line 1509 "glib-2.0.vapi"
	_tmp5__length1 = _result__length1;
#line 1509 "glib-2.0.vapi"
	_tmp6_ = string_length;
#line 1509 "glib-2.0.vapi"
	memcpy (_tmp5_, self, (gsize) _tmp6_);
#line 1510 "glib-2.0.vapi"
	_tmp7_ = _result_;
#line 1510 "glib-2.0.vapi"
	_tmp7__length1 = _result__length1;
#line 1510 "glib-2.0.vapi"
	if (result_length1) {
#line 1510 "glib-2.0.vapi"
		*result_length1 = _tmp7__length1;
#line 2606 "page.c"
	}
#line 1510 "glib-2.0.vapi"
	result = _tmp7_;
#line 1510 "glib-2.0.vapi"
	return result;
#line 2612 "page.c"
}


gchar*
page_get_icc_data_encoded (Page* self)
{
	gchar* result = NULL;
	const gchar* _tmp0_;
	gchar* contents = NULL;
	const gchar* _tmp5_;
	gint _tmp6_ = 0;
	gchar* _tmp7_;
	guchar* _tmp8_;
	gint _tmp8__length1;
	gchar* _tmp9_;
	gchar* _tmp10_;
	GError * _inner_error_ = NULL;
#line 629 "../src/page.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 631 "../src/page.vala"
	_tmp0_ = self->priv->_color_profile;
#line 631 "../src/page.vala"
	if (_tmp0_ == NULL) {
#line 632 "../src/page.vala"
		result = NULL;
#line 632 "../src/page.vala"
		return result;
#line 2640 "page.c"
	}
	{
		const gchar* _tmp1_;
		gchar* _tmp2_ = NULL;
#line 638 "../src/page.vala"
		_tmp1_ = self->priv->_color_profile;
#line 638 "../src/page.vala"
		g_file_get_contents (_tmp1_, &_tmp2_, NULL, &_inner_error_);
#line 638 "../src/page.vala"
		_g_free0 (contents);
#line 638 "../src/page.vala"
		contents = _tmp2_;
#line 638 "../src/page.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 2655 "page.c"
			goto __catch17_g_error;
		}
	}
	goto __finally17;
	__catch17_g_error:
	{
		GError* e = NULL;
		GError* _tmp3_;
		const gchar* _tmp4_;
#line 636 "../src/page.vala"
		e = _inner_error_;
#line 636 "../src/page.vala"
		_inner_error_ = NULL;
#line 642 "../src/page.vala"
		_tmp3_ = e;
#line 642 "../src/page.vala"
		_tmp4_ = _tmp3_->message;
#line 642 "../src/page.vala"
		g_warning ("page.vala:642: failed to get icc profile data: %s", _tmp4_);
#line 643 "../src/page.vala"
		result = NULL;
#line 643 "../src/page.vala"
		_g_error_free0 (e);
#line 643 "../src/page.vala"
		_g_free0 (contents);
#line 643 "../src/page.vala"
		return result;
#line 2683 "page.c"
	}
	__finally17:
#line 636 "../src/page.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 636 "../src/page.vala"
		_g_free0 (contents);
#line 636 "../src/page.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 636 "../src/page.vala"
		g_clear_error (&_inner_error_);
#line 636 "../src/page.vala"
		return NULL;
#line 2696 "page.c"
	}
#line 647 "../src/page.vala"
	_tmp5_ = contents;
#line 647 "../src/page.vala"
	_tmp7_ = string_to_utf8 (_tmp5_, &_tmp6_);
#line 647 "../src/page.vala"
	_tmp8_ = (guchar*) _tmp7_;
#line 647 "../src/page.vala"
	_tmp8__length1 = (_tmp6_ * sizeof (gchar)) / sizeof (guchar);
#line 647 "../src/page.vala"
	_tmp9_ = g_base64_encode (_tmp8_, (_tmp6_ * sizeof (gchar)) / sizeof (guchar));
#line 647 "../src/page.vala"
	_tmp10_ = _tmp9_;
#line 647 "../src/page.vala"
	_tmp8_ = (g_free (_tmp8_), NULL);
#line 647 "../src/page.vala"
	result = _tmp10_;
#line 647 "../src/page.vala"
	_g_free0 (contents);
#line 647 "../src/page.vala"
	return result;
#line 2718 "page.c"
}


static gpointer
_g_object_ref0 (gpointer self)
{
#line 652 "../src/page.vala"
	return self ? g_object_ref (self) : NULL;
#line 2727 "page.c"
}


void
page_copy_to_clipboard (Page* self,
                        GtkWindow* window)
{
	GdkDisplay* display = NULL;
	GdkDisplay* _tmp0_;
	GdkDisplay* _tmp1_;
	GtkClipboard* clipboard = NULL;
	GtkClipboard* _tmp2_;
	GtkClipboard* _tmp3_;
	GdkPixbuf* image = NULL;
	GdkPixbuf* _tmp4_;
#line 650 "../src/page.vala"
	g_return_if_fail (self != NULL);
#line 650 "../src/page.vala"
	g_return_if_fail (window != NULL);
#line 652 "../src/page.vala"
	_tmp0_ = gtk_widget_get_display ((GtkWidget*) window);
#line 652 "../src/page.vala"
	_tmp1_ = _g_object_ref0 (_tmp0_);
#line 652 "../src/page.vala"
	display = _tmp1_;
#line 653 "../src/page.vala"
	_tmp2_ = gtk_clipboard_get_for_display (display, GDK_SELECTION_CLIPBOARD);
#line 653 "../src/page.vala"
	_tmp3_ = _g_object_ref0 (_tmp2_);
#line 653 "../src/page.vala"
	clipboard = _tmp3_;
#line 654 "../src/page.vala"
	_tmp4_ = page_get_image (self, TRUE);
#line 654 "../src/page.vala"
	image = _tmp4_;
#line 655 "../src/page.vala"
	gtk_clipboard_set_image (clipboard, image);
#line 650 "../src/page.vala"
	_g_object_unref0 (image);
#line 650 "../src/page.vala"
	_g_object_unref0 (clipboard);
#line 650 "../src/page.vala"
	_g_object_unref0 (display);
#line 2771 "page.c"
}


static Block6Data*
block6_data_ref (Block6Data* _data6_)
{
#line 658 "../src/page.vala"
	g_atomic_int_inc (&_data6_->_ref_count_);
#line 658 "../src/page.vala"
	return _data6_;
#line 2782 "page.c"
}


static void
block6_data_unref (void * _userdata_)
{
	Block6Data* _data6_;
	_data6_ = (Block6Data*) _userdata_;
#line 658 "../src/page.vala"
	if (g_atomic_int_dec_and_test (&_data6_->_ref_count_)) {
#line 2793 "page.c"
		Page* self;
#line 658 "../src/page.vala"
		self = _data6_->self;
#line 658 "../src/page.vala"
		_g_object_unref0 (_data6_->stream);
#line 658 "../src/page.vala"
		_page_unref0 (self);
#line 658 "../src/page.vala"
		g_slice_free (Block6Data, _data6_);
#line 2803 "page.c"
	}
}


static gboolean
__lambda17_ (Block6Data* _data6_,
             guint8* buf,
             int buf_length1,
             GError** error)
{
	Page* self;
	gboolean result = FALSE;
	GFileOutputStream* _tmp0_;
	GError * _inner_error_ = NULL;
#line 672 "../src/page.vala"
	self = _data6_->self;
#line 674 "../src/page.vala"
	_tmp0_ = _data6_->stream;
#line 674 "../src/page.vala"
	g_output_stream_write_all ((GOutputStream*) _tmp0_, buf, (gsize) buf_length1, NULL, NULL, &_inner_error_);
#line 674 "../src/page.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 2826 "page.c"
		gboolean _tmp1_ = FALSE;
#line 674 "../src/page.vala"
		g_propagate_error (error, _inner_error_);
#line 674 "../src/page.vala"
		return _tmp1_;
#line 2832 "page.c"
	}
#line 675 "../src/page.vala"
	result = TRUE;
#line 675 "../src/page.vala"
	return result;
#line 2838 "page.c"
}


static gboolean
___lambda17__gdk_pixbuf_save_func (guint8* buf,
                                   gsize buf_length1,
                                   GError** error,
                                   gpointer self)
{
	gboolean result;
	result = __lambda17_ (self, buf, buf_length1, error);
#line 672 "../src/page.vala"
	return result;
#line 2852 "page.c"
}


void
page_save_png (Page* self,
               GFile* file,
               GError** error)
{
	Block6Data* _data6_;
	GFileOutputStream* _tmp0_;
	GdkPixbuf* image = NULL;
	GdkPixbuf* _tmp1_;
	gchar* icc_profile_data = NULL;
	const gchar* _tmp2_;
	gchar** keys = NULL;
	gchar* _tmp4_;
	gchar* _tmp5_;
	gchar* _tmp6_;
	gchar** _tmp7_;
	gint keys_length1;
	gint _keys_size_;
	gchar** values = NULL;
	gint _tmp8_;
	gchar* _tmp9_;
	gint _tmp10_;
	gchar* _tmp11_;
	const gchar* _tmp12_;
	gchar* _tmp13_;
	gchar** _tmp14_;
	gint values_length1;
	gint _values_size_;
	const gchar* _tmp15_;
	GdkPixbuf* _tmp18_;
	gchar** _tmp19_;
	gint _tmp19__length1;
	gchar** _tmp20_;
	gint _tmp20__length1;
	GError * _inner_error_ = NULL;
#line 658 "../src/page.vala"
	g_return_if_fail (self != NULL);
#line 658 "../src/page.vala"
	g_return_if_fail (file != NULL);
#line 658 "../src/page.vala"
	_data6_ = g_slice_new0 (Block6Data);
#line 658 "../src/page.vala"
	_data6_->_ref_count_ = 1;
#line 658 "../src/page.vala"
	_data6_->self = page_ref (self);
#line 660 "../src/page.vala"
	_tmp0_ = g_file_replace (file, NULL, FALSE, G_FILE_CREATE_NONE, NULL, &_inner_error_);
#line 660 "../src/page.vala"
	_data6_->stream = _tmp0_;
#line 660 "../src/page.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 660 "../src/page.vala"
		g_propagate_error (error, _inner_error_);
#line 660 "../src/page.vala"
		block6_data_unref (_data6_);
#line 660 "../src/page.vala"
		_data6_ = NULL;
#line 660 "../src/page.vala"
		return;
#line 2915 "page.c"
	}
#line 661 "../src/page.vala"
	_tmp1_ = page_get_image (self, TRUE);
#line 661 "../src/page.vala"
	image = _tmp1_;
#line 663 "../src/page.vala"
	icc_profile_data = NULL;
#line 664 "../src/page.vala"
	_tmp2_ = self->priv->_color_profile;
#line 664 "../src/page.vala"
	if (_tmp2_ != NULL) {
#line 2927 "page.c"
		gchar* _tmp3_;
#line 665 "../src/page.vala"
		_tmp3_ = page_get_icc_data_encoded (self);
#line 665 "../src/page.vala"
		_g_free0 (icc_profile_data);
#line 665 "../src/page.vala"
		icc_profile_data = _tmp3_;
#line 2935 "page.c"
	}
#line 667 "../src/page.vala"
	_tmp4_ = g_strdup ("x-dpi");
#line 667 "../src/page.vala"
	_tmp5_ = g_strdup ("y-dpi");
#line 667 "../src/page.vala"
	_tmp6_ = g_strdup ("icc-profile");
#line 667 "../src/page.vala"
	_tmp7_ = g_new0 (gchar*, 4 + 1);
#line 667 "../src/page.vala"
	_tmp7_[0] = _tmp4_;
#line 667 "../src/page.vala"
	_tmp7_[1] = _tmp5_;
#line 667 "../src/page.vala"
	_tmp7_[2] = _tmp6_;
#line 667 "../src/page.vala"
	_tmp7_[3] = NULL;
#line 667 "../src/page.vala"
	keys = _tmp7_;
#line 667 "../src/page.vala"
	keys_length1 = 4;
#line 667 "../src/page.vala"
	_keys_size_ = keys_length1;
#line 668 "../src/page.vala"
	_tmp8_ = self->priv->_dpi;
#line 668 "../src/page.vala"
	_tmp9_ = g_strdup_printf ("%d", _tmp8_);
#line 668 "../src/page.vala"
	_tmp10_ = self->priv->_dpi;
#line 668 "../src/page.vala"
	_tmp11_ = g_strdup_printf ("%d", _tmp10_);
#line 668 "../src/page.vala"
	_tmp12_ = icc_profile_data;
#line 668 "../src/page.vala"
	_tmp13_ = g_strdup (_tmp12_);
#line 668 "../src/page.vala"
	_tmp14_ = g_new0 (gchar*, 4 + 1);
#line 668 "../src/page.vala"
	_tmp14_[0] = _tmp9_;
#line 668 "../src/page.vala"
	_tmp14_[1] = _tmp11_;
#line 668 "../src/page.vala"
	_tmp14_[2] = _tmp13_;
#line 668 "../src/page.vala"
	_tmp14_[3] = NULL;
#line 668 "../src/page.vala"
	values = _tmp14_;
#line 668 "../src/page.vala"
	values_length1 = 4;
#line 668 "../src/page.vala"
	_values_size_ = values_length1;
#line 669 "../src/page.vala"
	_tmp15_ = icc_profile_data;
#line 669 "../src/page.vala"
	if (_tmp15_ == NULL) {
#line 2991 "page.c"
		gchar** _tmp16_;
		gint _tmp16__length1;
		gchar* _tmp17_;
#line 670 "../src/page.vala"
		_tmp16_ = keys;
#line 670 "../src/page.vala"
		_tmp16__length1 = keys_length1;
#line 670 "../src/page.vala"
		_g_free0 (_tmp16_[2]);
#line 670 "../src/page.vala"
		_tmp16_[2] = NULL;
#line 670 "../src/page.vala"
		_tmp17_ = _tmp16_[2];
#line 3005 "page.c"
	}
#line 672 "../src/page.vala"
	_tmp18_ = image;
#line 672 "../src/page.vala"
	_tmp19_ = keys;
#line 672 "../src/page.vala"
	_tmp19__length1 = keys_length1;
#line 672 "../src/page.vala"
	_tmp20_ = values;
#line 672 "../src/page.vala"
	_tmp20__length1 = values_length1;
#line 672 "../src/page.vala"
	gdk_pixbuf_save_to_callbackv (_tmp18_, ___lambda17__gdk_pixbuf_save_func, _data6_, "png", _tmp19_, _tmp20_, &_inner_error_);
#line 672 "../src/page.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 672 "../src/page.vala"
		g_propagate_error (error, _inner_error_);
#line 672 "../src/page.vala"
		values = (_vala_array_free (values, values_length1, (GDestroyNotify) g_free), NULL);
#line 672 "../src/page.vala"
		keys = (_vala_array_free (keys, keys_length1, (GDestroyNotify) g_free), NULL);
#line 672 "../src/page.vala"
		_g_free0 (icc_profile_data);
#line 672 "../src/page.vala"
		_g_object_unref0 (image);
#line 672 "../src/page.vala"
		block6_data_unref (_data6_);
#line 672 "../src/page.vala"
		_data6_ = NULL;
#line 672 "../src/page.vala"
		return;
#line 3037 "page.c"
	}
#line 658 "../src/page.vala"
	values = (_vala_array_free (values, values_length1, (GDestroyNotify) g_free), NULL);
#line 658 "../src/page.vala"
	keys = (_vala_array_free (keys, keys_length1, (GDestroyNotify) g_free), NULL);
#line 658 "../src/page.vala"
	_g_free0 (icc_profile_data);
#line 658 "../src/page.vala"
	_g_object_unref0 (image);
#line 658 "../src/page.vala"
	block6_data_unref (_data6_);
#line 658 "../src/page.vala"
	_data6_ = NULL;
#line 3051 "page.c"
}


gint
page_get_width (Page* self)
{
	gint result;
	gboolean _tmp0_ = FALSE;
	ScanDirection _tmp1_;
	ScanDirection _tmp2_;
#line 25 "../src/page.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 27 "../src/page.vala"
	_tmp1_ = page_get_scan_direction (self);
#line 27 "../src/page.vala"
	_tmp2_ = _tmp1_;
#line 27 "../src/page.vala"
	if (_tmp2_ == SCAN_DIRECTION_TOP_TO_BOTTOM) {
#line 27 "../src/page.vala"
		_tmp0_ = TRUE;
#line 3072 "page.c"
	} else {
		ScanDirection _tmp3_;
		ScanDirection _tmp4_;
#line 27 "../src/page.vala"
		_tmp3_ = page_get_scan_direction (self);
#line 27 "../src/page.vala"
		_tmp4_ = _tmp3_;
#line 27 "../src/page.vala"
		_tmp0_ = _tmp4_ == SCAN_DIRECTION_BOTTOM_TO_TOP;
#line 3082 "page.c"
	}
#line 27 "../src/page.vala"
	if (_tmp0_) {
#line 3086 "page.c"
		gint _tmp5_;
#line 28 "../src/page.vala"
		_tmp5_ = self->priv->_scan_width;
#line 28 "../src/page.vala"
		result = _tmp5_;
#line 28 "../src/page.vala"
		return result;
#line 3094 "page.c"
	} else {
		gint _tmp6_;
#line 30 "../src/page.vala"
		_tmp6_ = self->priv->_scan_height;
#line 30 "../src/page.vala"
		result = _tmp6_;
#line 30 "../src/page.vala"
		return result;
#line 3103 "page.c"
	}
}


gint
page_get_height (Page* self)
{
	gint result;
	gboolean _tmp0_ = FALSE;
	ScanDirection _tmp1_;
	ScanDirection _tmp2_;
#line 37 "../src/page.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 39 "../src/page.vala"
	_tmp1_ = page_get_scan_direction (self);
#line 39 "../src/page.vala"
	_tmp2_ = _tmp1_;
#line 39 "../src/page.vala"
	if (_tmp2_ == SCAN_DIRECTION_TOP_TO_BOTTOM) {
#line 39 "../src/page.vala"
		_tmp0_ = TRUE;
#line 3125 "page.c"
	} else {
		ScanDirection _tmp3_;
		ScanDirection _tmp4_;
#line 39 "../src/page.vala"
		_tmp3_ = page_get_scan_direction (self);
#line 39 "../src/page.vala"
		_tmp4_ = _tmp3_;
#line 39 "../src/page.vala"
		_tmp0_ = _tmp4_ == SCAN_DIRECTION_BOTTOM_TO_TOP;
#line 3135 "page.c"
	}
#line 39 "../src/page.vala"
	if (_tmp0_) {
#line 3139 "page.c"
		gint _tmp5_;
#line 40 "../src/page.vala"
		_tmp5_ = self->priv->_scan_height;
#line 40 "../src/page.vala"
		result = _tmp5_;
#line 40 "../src/page.vala"
		return result;
#line 3147 "page.c"
	} else {
		gint _tmp6_;
#line 42 "../src/page.vala"
		_tmp6_ = self->priv->_scan_width;
#line 42 "../src/page.vala"
		result = _tmp6_;
#line 42 "../src/page.vala"
		return result;
#line 3156 "page.c"
	}
}


gboolean
page_get_is_landscape (Page* self)
{
	gboolean result;
	gint _tmp0_;
	gint _tmp1_;
	gint _tmp2_;
	gint _tmp3_;
#line 47 "../src/page.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 47 "../src/page.vala"
	_tmp0_ = page_get_width (self);
#line 47 "../src/page.vala"
	_tmp1_ = _tmp0_;
#line 47 "../src/page.vala"
	_tmp2_ = page_get_height (self);
#line 47 "../src/page.vala"
	_tmp3_ = _tmp2_;
#line 47 "../src/page.vala"
	result = _tmp1_ > _tmp3_;
#line 47 "../src/page.vala"
	return result;
#line 3183 "page.c"
}


gint
page_get_dpi (Page* self)
{
	gint result;
	gint _tmp0_;
#line 50 "../src/page.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 50 "../src/page.vala"
	_tmp0_ = self->priv->_dpi;
#line 50 "../src/page.vala"
	result = _tmp0_;
#line 50 "../src/page.vala"
	return result;
#line 3200 "page.c"
}


static void
page_set_dpi (Page* self,
              gint value)
{
#line 50 "../src/page.vala"
	g_return_if_fail (self != NULL);
#line 50 "../src/page.vala"
	self->priv->_dpi = value;
#line 3212 "page.c"
}


gint
page_get_depth (Page* self)
{
	gint result;
	gint _tmp0_;
#line 56 "../src/page.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 56 "../src/page.vala"
	_tmp0_ = self->priv->_depth;
#line 56 "../src/page.vala"
	result = _tmp0_;
#line 56 "../src/page.vala"
	return result;
#line 3229 "page.c"
}


static void
page_set_depth (Page* self,
                gint value)
{
#line 56 "../src/page.vala"
	g_return_if_fail (self != NULL);
#line 56 "../src/page.vala"
	self->priv->_depth = value;
#line 3241 "page.c"
}


const gchar*
page_get_color_profile (Page* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 59 "../src/page.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 59 "../src/page.vala"
	_tmp0_ = self->priv->_color_profile;
#line 59 "../src/page.vala"
	result = _tmp0_;
#line 59 "../src/page.vala"
	return result;
#line 3258 "page.c"
}


void
page_set_color_profile (Page* self,
                        const gchar* value)
{
	gchar* _tmp0_;
#line 59 "../src/page.vala"
	g_return_if_fail (self != NULL);
#line 59 "../src/page.vala"
	_tmp0_ = g_strdup (value);
#line 59 "../src/page.vala"
	_g_free0 (self->priv->_color_profile);
#line 59 "../src/page.vala"
	self->priv->_color_profile = _tmp0_;
#line 3275 "page.c"
}


gint
page_get_scan_width (Page* self)
{
	gint result;
	gint _tmp0_;
#line 62 "../src/page.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 62 "../src/page.vala"
	_tmp0_ = self->priv->_scan_width;
#line 62 "../src/page.vala"
	result = _tmp0_;
#line 62 "../src/page.vala"
	return result;
#line 3292 "page.c"
}


static void
page_set_scan_width (Page* self,
                     gint value)
{
#line 62 "../src/page.vala"
	g_return_if_fail (self != NULL);
#line 62 "../src/page.vala"
	self->priv->_scan_width = value;
#line 3304 "page.c"
}


gint
page_get_scan_height (Page* self)
{
	gint result;
	gint _tmp0_;
#line 65 "../src/page.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 65 "../src/page.vala"
	_tmp0_ = self->priv->_scan_height;
#line 65 "../src/page.vala"
	result = _tmp0_;
#line 65 "../src/page.vala"
	return result;
#line 3321 "page.c"
}


static void
page_set_scan_height (Page* self,
                      gint value)
{
#line 65 "../src/page.vala"
	g_return_if_fail (self != NULL);
#line 65 "../src/page.vala"
	self->priv->_scan_height = value;
#line 3333 "page.c"
}


gint
page_get_rowstride (Page* self)
{
	gint result;
	gint _tmp0_;
#line 68 "../src/page.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 68 "../src/page.vala"
	_tmp0_ = self->priv->_rowstride;
#line 68 "../src/page.vala"
	result = _tmp0_;
#line 68 "../src/page.vala"
	return result;
#line 3350 "page.c"
}


static void
page_set_rowstride (Page* self,
                    gint value)
{
#line 68 "../src/page.vala"
	g_return_if_fail (self != NULL);
#line 68 "../src/page.vala"
	self->priv->_rowstride = value;
#line 3362 "page.c"
}


gint
page_get_n_channels (Page* self)
{
	gint result;
	gint _tmp0_;
#line 71 "../src/page.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 71 "../src/page.vala"
	_tmp0_ = self->priv->_n_channels;
#line 71 "../src/page.vala"
	result = _tmp0_;
#line 71 "../src/page.vala"
	return result;
#line 3379 "page.c"
}


static void
page_set_n_channels (Page* self,
                     gint value)
{
#line 71 "../src/page.vala"
	g_return_if_fail (self != NULL);
#line 71 "../src/page.vala"
	self->priv->_n_channels = value;
#line 3391 "page.c"
}


gboolean
page_get_is_scanning (Page* self)
{
	gboolean result;
	gboolean _tmp0_;
#line 77 "../src/page.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 77 "../src/page.vala"
	_tmp0_ = self->priv->_is_scanning;
#line 77 "../src/page.vala"
	result = _tmp0_;
#line 77 "../src/page.vala"
	return result;
#line 3408 "page.c"
}


static void
page_set_is_scanning (Page* self,
                      gboolean value)
{
#line 77 "../src/page.vala"
	g_return_if_fail (self != NULL);
#line 77 "../src/page.vala"
	self->priv->_is_scanning = value;
#line 3420 "page.c"
}


gboolean
page_get_has_data (Page* self)
{
	gboolean result;
	gboolean _tmp0_;
#line 80 "../src/page.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 80 "../src/page.vala"
	_tmp0_ = self->priv->_has_data;
#line 80 "../src/page.vala"
	result = _tmp0_;
#line 80 "../src/page.vala"
	return result;
#line 3437 "page.c"
}


static void
page_set_has_data (Page* self,
                   gboolean value)
{
#line 80 "../src/page.vala"
	g_return_if_fail (self != NULL);
#line 80 "../src/page.vala"
	self->priv->_has_data = value;
#line 3449 "page.c"
}


gint
page_get_scan_line (Page* self)
{
	gint result;
	gint _tmp0_;
#line 83 "../src/page.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 83 "../src/page.vala"
	_tmp0_ = self->priv->_scan_line;
#line 83 "../src/page.vala"
	result = _tmp0_;
#line 83 "../src/page.vala"
	return result;
#line 3466 "page.c"
}


static void
page_set_scan_line (Page* self,
                    gint value)
{
#line 83 "../src/page.vala"
	g_return_if_fail (self != NULL);
#line 83 "../src/page.vala"
	self->priv->_scan_line = value;
#line 3478 "page.c"
}


gboolean
page_get_is_color (Page* self)
{
	gboolean result;
	gint _tmp0_;
#line 86 "../src/page.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 86 "../src/page.vala"
	_tmp0_ = self->priv->_n_channels;
#line 86 "../src/page.vala"
	result = _tmp0_ > 1;
#line 86 "../src/page.vala"
	return result;
#line 3495 "page.c"
}


ScanDirection
page_get_scan_direction (Page* self)
{
	ScanDirection result;
	ScanDirection _tmp0_;
#line 92 "../src/page.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 92 "../src/page.vala"
	_tmp0_ = self->priv->scan_direction_;
#line 92 "../src/page.vala"
	result = _tmp0_;
#line 92 "../src/page.vala"
	return result;
#line 3512 "page.c"
}


void
page_set_scan_direction (Page* self,
                         ScanDirection value)
{
	ScanDirection _tmp0_;
	gboolean size_has_changed = FALSE;
	gint left_steps = 0;
	ScanDirection _tmp1_;
	gint _tmp2_;
	gint _tmp4_;
	gboolean _tmp5_;
	gboolean _tmp33_;
	gboolean _tmp34_;
#line 94 "../src/page.vala"
	g_return_if_fail (self != NULL);
#line 96 "../src/page.vala"
	_tmp0_ = self->priv->scan_direction_;
#line 96 "../src/page.vala"
	if (_tmp0_ == value) {
#line 97 "../src/page.vala"
		return;
#line 3537 "page.c"
	}
#line 100 "../src/page.vala"
	size_has_changed = FALSE;
#line 101 "../src/page.vala"
	_tmp1_ = self->priv->scan_direction_;
#line 101 "../src/page.vala"
	left_steps = (gint) (value - _tmp1_);
#line 102 "../src/page.vala"
	_tmp2_ = left_steps;
#line 102 "../src/page.vala"
	if (_tmp2_ < 0) {
#line 3549 "page.c"
		gint _tmp3_;
#line 103 "../src/page.vala"
		_tmp3_ = left_steps;
#line 103 "../src/page.vala"
		left_steps = _tmp3_ + 4;
#line 3555 "page.c"
	}
#line 104 "../src/page.vala"
	_tmp4_ = left_steps;
#line 104 "../src/page.vala"
	if (_tmp4_ != 2) {
#line 105 "../src/page.vala"
		size_has_changed = TRUE;
#line 3563 "page.c"
	}
#line 108 "../src/page.vala"
	_tmp5_ = self->priv->_has_crop;
#line 108 "../src/page.vala"
	if (_tmp5_) {
#line 3569 "page.c"
		gint _tmp6_;
#line 110 "../src/page.vala"
		_tmp6_ = left_steps;
#line 110 "../src/page.vala"
		switch (_tmp6_) {
#line 110 "../src/page.vala"
			case 1:
#line 3577 "page.c"
			{
				gint t = 0;
				gint _tmp7_;
				gint _tmp8_;
				gint _tmp9_;
				gint _tmp10_;
				gint _tmp11_;
				gint _tmp12_;
				gint _tmp13_;
				gint _tmp14_;
				gint _tmp15_;
#line 114 "../src/page.vala"
				_tmp7_ = self->priv->_crop_x;
#line 114 "../src/page.vala"
				t = _tmp7_;
#line 115 "../src/page.vala"
				_tmp8_ = self->priv->_crop_y;
#line 115 "../src/page.vala"
				page_set_crop_x (self, _tmp8_);
#line 116 "../src/page.vala"
				_tmp9_ = page_get_width (self);
#line 116 "../src/page.vala"
				_tmp10_ = _tmp9_;
#line 116 "../src/page.vala"
				_tmp11_ = t;
#line 116 "../src/page.vala"
				_tmp12_ = self->priv->_crop_width;
#line 116 "../src/page.vala"
				page_set_crop_y (self, _tmp10_ - (_tmp11_ + _tmp12_));
#line 117 "../src/page.vala"
				_tmp13_ = self->priv->_crop_width;
#line 117 "../src/page.vala"
				t = _tmp13_;
#line 118 "../src/page.vala"
				_tmp14_ = self->priv->_crop_height;
#line 118 "../src/page.vala"
				page_set_crop_width (self, _tmp14_);
#line 119 "../src/page.vala"
				_tmp15_ = t;
#line 119 "../src/page.vala"
				page_set_crop_height (self, _tmp15_);
#line 120 "../src/page.vala"
				break;
#line 3621 "page.c"
			}
#line 110 "../src/page.vala"
			case 2:
#line 3625 "page.c"
			{
				gint _tmp16_;
				gint _tmp17_;
				gint _tmp18_;
				gint _tmp19_;
				gint _tmp20_;
				gint _tmp21_;
				gint _tmp22_;
				gint _tmp23_;
#line 123 "../src/page.vala"
				_tmp16_ = page_get_width (self);
#line 123 "../src/page.vala"
				_tmp17_ = _tmp16_;
#line 123 "../src/page.vala"
				_tmp18_ = self->priv->_crop_x;
#line 123 "../src/page.vala"
				_tmp19_ = self->priv->_crop_width;
#line 123 "../src/page.vala"
				page_set_crop_x (self, _tmp17_ - (_tmp18_ + _tmp19_));
#line 124 "../src/page.vala"
				_tmp20_ = page_get_width (self);
#line 124 "../src/page.vala"
				_tmp21_ = _tmp20_;
#line 124 "../src/page.vala"
				_tmp22_ = self->priv->_crop_y;
#line 124 "../src/page.vala"
				_tmp23_ = self->priv->_crop_height;
#line 124 "../src/page.vala"
				page_set_crop_y (self, _tmp21_ - (_tmp22_ + _tmp23_));
#line 125 "../src/page.vala"
				break;
#line 3657 "page.c"
			}
#line 110 "../src/page.vala"
			case 3:
#line 3661 "page.c"
			{
				gint t = 0;
				gint _tmp24_;
				gint _tmp25_;
				gint _tmp26_;
				gint _tmp27_;
				gint _tmp28_;
				gint _tmp29_;
				gint _tmp30_;
				gint _tmp31_;
				gint _tmp32_;
#line 128 "../src/page.vala"
				_tmp24_ = self->priv->_crop_y;
#line 128 "../src/page.vala"
				t = _tmp24_;
#line 129 "../src/page.vala"
				_tmp25_ = self->priv->_crop_x;
#line 129 "../src/page.vala"
				page_set_crop_y (self, _tmp25_);
#line 130 "../src/page.vala"
				_tmp26_ = page_get_height (self);
#line 130 "../src/page.vala"
				_tmp27_ = _tmp26_;
#line 130 "../src/page.vala"
				_tmp28_ = t;
#line 130 "../src/page.vala"
				_tmp29_ = self->priv->_crop_height;
#line 130 "../src/page.vala"
				page_set_crop_x (self, _tmp27_ - (_tmp28_ + _tmp29_));
#line 131 "../src/page.vala"
				_tmp30_ = self->priv->_crop_width;
#line 131 "../src/page.vala"
				t = _tmp30_;
#line 132 "../src/page.vala"
				_tmp31_ = self->priv->_crop_height;
#line 132 "../src/page.vala"
				page_set_crop_width (self, _tmp31_);
#line 133 "../src/page.vala"
				_tmp32_ = t;
#line 133 "../src/page.vala"
				page_set_crop_height (self, _tmp32_);
#line 134 "../src/page.vala"
				break;
#line 3705 "page.c"
			}
			default:
#line 110 "../src/page.vala"
			break;
#line 3710 "page.c"
		}
	}
#line 138 "../src/page.vala"
	self->priv->scan_direction_ = value;
#line 139 "../src/page.vala"
	_tmp33_ = size_has_changed;
#line 139 "../src/page.vala"
	if (_tmp33_) {
#line 140 "../src/page.vala"
		g_signal_emit (self, page_signals[PAGE_SIZE_CHANGED_SIGNAL], 0);
#line 3721 "page.c"
	}
#line 141 "../src/page.vala"
	g_signal_emit (self, page_signals[PAGE_SCAN_DIRECTION_CHANGED_SIGNAL], 0);
#line 142 "../src/page.vala"
	_tmp34_ = self->priv->_has_crop;
#line 142 "../src/page.vala"
	if (_tmp34_) {
#line 143 "../src/page.vala"
		g_signal_emit (self, page_signals[PAGE_CROP_CHANGED_SIGNAL], 0);
#line 3731 "page.c"
	}
}


gboolean
page_get_has_crop (Page* self)
{
	gboolean result;
	gboolean _tmp0_;
#line 148 "../src/page.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 148 "../src/page.vala"
	_tmp0_ = self->priv->_has_crop;
#line 148 "../src/page.vala"
	result = _tmp0_;
#line 148 "../src/page.vala"
	return result;
#line 3749 "page.c"
}


static void
page_set_has_crop (Page* self,
                   gboolean value)
{
#line 148 "../src/page.vala"
	g_return_if_fail (self != NULL);
#line 148 "../src/page.vala"
	self->priv->_has_crop = value;
#line 3761 "page.c"
}


const gchar*
page_get_crop_name (Page* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 151 "../src/page.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 151 "../src/page.vala"
	_tmp0_ = self->priv->_crop_name;
#line 151 "../src/page.vala"
	result = _tmp0_;
#line 151 "../src/page.vala"
	return result;
#line 3778 "page.c"
}


static void
page_set_crop_name (Page* self,
                    const gchar* value)
{
	gchar* _tmp0_;
#line 151 "../src/page.vala"
	g_return_if_fail (self != NULL);
#line 151 "../src/page.vala"
	_tmp0_ = g_strdup (value);
#line 151 "../src/page.vala"
	_g_free0 (self->priv->_crop_name);
#line 151 "../src/page.vala"
	self->priv->_crop_name = _tmp0_;
#line 3795 "page.c"
}


gint
page_get_crop_x (Page* self)
{
	gint result;
	gint _tmp0_;
#line 154 "../src/page.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 154 "../src/page.vala"
	_tmp0_ = self->priv->_crop_x;
#line 154 "../src/page.vala"
	result = _tmp0_;
#line 154 "../src/page.vala"
	return result;
#line 3812 "page.c"
}


static void
page_set_crop_x (Page* self,
                 gint value)
{
#line 154 "../src/page.vala"
	g_return_if_fail (self != NULL);
#line 154 "../src/page.vala"
	self->priv->_crop_x = value;
#line 3824 "page.c"
}


gint
page_get_crop_y (Page* self)
{
	gint result;
	gint _tmp0_;
#line 157 "../src/page.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 157 "../src/page.vala"
	_tmp0_ = self->priv->_crop_y;
#line 157 "../src/page.vala"
	result = _tmp0_;
#line 157 "../src/page.vala"
	return result;
#line 3841 "page.c"
}


static void
page_set_crop_y (Page* self,
                 gint value)
{
#line 157 "../src/page.vala"
	g_return_if_fail (self != NULL);
#line 157 "../src/page.vala"
	self->priv->_crop_y = value;
#line 3853 "page.c"
}


gint
page_get_crop_width (Page* self)
{
	gint result;
	gint _tmp0_;
#line 160 "../src/page.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 160 "../src/page.vala"
	_tmp0_ = self->priv->_crop_width;
#line 160 "../src/page.vala"
	result = _tmp0_;
#line 160 "../src/page.vala"
	return result;
#line 3870 "page.c"
}


static void
page_set_crop_width (Page* self,
                     gint value)
{
#line 160 "../src/page.vala"
	g_return_if_fail (self != NULL);
#line 160 "../src/page.vala"
	self->priv->_crop_width = value;
#line 3882 "page.c"
}


gint
page_get_crop_height (Page* self)
{
	gint result;
	gint _tmp0_;
#line 163 "../src/page.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 163 "../src/page.vala"
	_tmp0_ = self->priv->_crop_height;
#line 163 "../src/page.vala"
	result = _tmp0_;
#line 163 "../src/page.vala"
	return result;
#line 3899 "page.c"
}


static void
page_set_crop_height (Page* self,
                      gint value)
{
#line 163 "../src/page.vala"
	g_return_if_fail (self != NULL);
#line 163 "../src/page.vala"
	self->priv->_crop_height = value;
#line 3911 "page.c"
}


static void
value_page_init (GValue* value)
{
#line 20 "../src/page.vala"
	value->data[0].v_pointer = NULL;
#line 3920 "page.c"
}


static void
value_page_free_value (GValue* value)
{
#line 20 "../src/page.vala"
	if (value->data[0].v_pointer) {
#line 20 "../src/page.vala"
		page_unref (value->data[0].v_pointer);
#line 3931 "page.c"
	}
}


static void
value_page_copy_value (const GValue* src_value,
                       GValue* dest_value)
{
#line 20 "../src/page.vala"
	if (src_value->data[0].v_pointer) {
#line 20 "../src/page.vala"
		dest_value->data[0].v_pointer = page_ref (src_value->data[0].v_pointer);
#line 3944 "page.c"
	} else {
#line 20 "../src/page.vala"
		dest_value->data[0].v_pointer = NULL;
#line 3948 "page.c"
	}
}


static gpointer
value_page_peek_pointer (const GValue* value)
{
#line 20 "../src/page.vala"
	return value->data[0].v_pointer;
#line 3958 "page.c"
}


static gchar*
value_page_collect_value (GValue* value,
                          guint n_collect_values,
                          GTypeCValue* collect_values,
                          guint collect_flags)
{
#line 20 "../src/page.vala"
	if (collect_values[0].v_pointer) {
#line 3970 "page.c"
		Page * object;
		object = collect_values[0].v_pointer;
#line 20 "../src/page.vala"
		if (object->parent_instance.g_class == NULL) {
#line 20 "../src/page.vala"
			return g_strconcat ("invalid unclassed object pointer for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 3977 "page.c"
		} else if (!g_value_type_compatible (G_TYPE_FROM_INSTANCE (object), G_VALUE_TYPE (value))) {
#line 20 "../src/page.vala"
			return g_strconcat ("invalid object type `", g_type_name (G_TYPE_FROM_INSTANCE (object)), "' for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 3981 "page.c"
		}
#line 20 "../src/page.vala"
		value->data[0].v_pointer = page_ref (object);
#line 3985 "page.c"
	} else {
#line 20 "../src/page.vala"
		value->data[0].v_pointer = NULL;
#line 3989 "page.c"
	}
#line 20 "../src/page.vala"
	return NULL;
#line 3993 "page.c"
}


static gchar*
value_page_lcopy_value (const GValue* value,
                        guint n_collect_values,
                        GTypeCValue* collect_values,
                        guint collect_flags)
{
	Page ** object_p;
	object_p = collect_values[0].v_pointer;
#line 20 "../src/page.vala"
	if (!object_p) {
#line 20 "../src/page.vala"
		return g_strdup_printf ("value location for `%s' passed as NULL", G_VALUE_TYPE_NAME (value));
#line 4009 "page.c"
	}
#line 20 "../src/page.vala"
	if (!value->data[0].v_pointer) {
#line 20 "../src/page.vala"
		*object_p = NULL;
#line 4015 "page.c"
	} else if (collect_flags & G_VALUE_NOCOPY_CONTENTS) {
#line 20 "../src/page.vala"
		*object_p = value->data[0].v_pointer;
#line 4019 "page.c"
	} else {
#line 20 "../src/page.vala"
		*object_p = page_ref (value->data[0].v_pointer);
#line 4023 "page.c"
	}
#line 20 "../src/page.vala"
	return NULL;
#line 4027 "page.c"
}


GParamSpec*
param_spec_page (const gchar* name,
                 const gchar* nick,
                 const gchar* blurb,
                 GType object_type,
                 GParamFlags flags)
{
	ParamSpecPage* spec;
#line 20 "../src/page.vala"
	g_return_val_if_fail (g_type_is_a (object_type, TYPE_PAGE), NULL);
#line 20 "../src/page.vala"
	spec = g_param_spec_internal (G_TYPE_PARAM_OBJECT, name, nick, blurb, flags);
#line 20 "../src/page.vala"
	G_PARAM_SPEC (spec)->value_type = object_type;
#line 20 "../src/page.vala"
	return G_PARAM_SPEC (spec);
#line 4047 "page.c"
}


gpointer
value_get_page (const GValue* value)
{
#line 20 "../src/page.vala"
	g_return_val_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_PAGE), NULL);
#line 20 "../src/page.vala"
	return value->data[0].v_pointer;
#line 4058 "page.c"
}


void
value_set_page (GValue* value,
                gpointer v_object)
{
	Page * old;
#line 20 "../src/page.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_PAGE));
#line 20 "../src/page.vala"
	old = value->data[0].v_pointer;
#line 20 "../src/page.vala"
	if (v_object) {
#line 20 "../src/page.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, TYPE_PAGE));
#line 20 "../src/page.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 20 "../src/page.vala"
		value->data[0].v_pointer = v_object;
#line 20 "../src/page.vala"
		page_ref (value->data[0].v_pointer);
#line 4081 "page.c"
	} else {
#line 20 "../src/page.vala"
		value->data[0].v_pointer = NULL;
#line 4085 "page.c"
	}
#line 20 "../src/page.vala"
	if (old) {
#line 20 "../src/page.vala"
		page_unref (old);
#line 4091 "page.c"
	}
}


void
value_take_page (GValue* value,
                 gpointer v_object)
{
	Page * old;
#line 20 "../src/page.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_PAGE));
#line 20 "../src/page.vala"
	old = value->data[0].v_pointer;
#line 20 "../src/page.vala"
	if (v_object) {
#line 20 "../src/page.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, TYPE_PAGE));
#line 20 "../src/page.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 20 "../src/page.vala"
		value->data[0].v_pointer = v_object;
#line 4113 "page.c"
	} else {
#line 20 "../src/page.vala"
		value->data[0].v_pointer = NULL;
#line 4117 "page.c"
	}
#line 20 "../src/page.vala"
	if (old) {
#line 20 "../src/page.vala"
		page_unref (old);
#line 4123 "page.c"
	}
}


static void
page_class_init (PageClass * klass)
{
#line 20 "../src/page.vala"
	page_parent_class = g_type_class_peek_parent (klass);
#line 20 "../src/page.vala"
	((PageClass *) klass)->finalize = page_finalize;
#line 20 "../src/page.vala"
	g_type_class_adjust_private_offset (klass, &Page_private_offset);
#line 20 "../src/page.vala"
	page_signals[PAGE_PIXELS_CHANGED_SIGNAL] = g_signal_new ("pixels-changed", TYPE_PAGE, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 20 "../src/page.vala"
	page_signals[PAGE_SIZE_CHANGED_SIGNAL] = g_signal_new ("size-changed", TYPE_PAGE, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 20 "../src/page.vala"
	page_signals[PAGE_SCAN_LINE_CHANGED_SIGNAL] = g_signal_new ("scan-line-changed", TYPE_PAGE, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 20 "../src/page.vala"
	page_signals[PAGE_SCAN_DIRECTION_CHANGED_SIGNAL] = g_signal_new ("scan-direction-changed", TYPE_PAGE, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 20 "../src/page.vala"
	page_signals[PAGE_CROP_CHANGED_SIGNAL] = g_signal_new ("crop-changed", TYPE_PAGE, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 20 "../src/page.vala"
	page_signals[PAGE_SCAN_FINISHED_SIGNAL] = g_signal_new ("scan-finished", TYPE_PAGE, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 4149 "page.c"
}


static void
page_instance_init (Page * self)
{
#line 20 "../src/page.vala"
	self->priv = page_get_instance_private (self);
#line 89 "../src/page.vala"
	self->priv->scan_direction_ = SCAN_DIRECTION_TOP_TO_BOTTOM;
#line 20 "../src/page.vala"
	self->ref_count = 1;
#line 4162 "page.c"
}


static void
page_finalize (Page * obj)
{
	Page * self;
#line 20 "../src/page.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_PAGE, Page);
#line 20 "../src/page.vala"
	g_signal_handlers_destroy (self);
#line 59 "../src/page.vala"
	_g_free0 (self->priv->_color_profile);
#line 74 "../src/page.vala"
	self->priv->pixels = (g_free (self->priv->pixels), NULL);
#line 151 "../src/page.vala"
	_g_free0 (self->priv->_crop_name);
#line 4180 "page.c"
}


GType
page_get_type (void)
{
	static volatile gsize page_type_id__volatile = 0;
	if (g_once_init_enter (&page_type_id__volatile)) {
		static const GTypeValueTable g_define_type_value_table = { value_page_init, value_page_free_value, value_page_copy_value, value_page_peek_pointer, "p", value_page_collect_value, "p", value_page_lcopy_value };
		static const GTypeInfo g_define_type_info = { sizeof (PageClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) page_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (Page), 0, (GInstanceInitFunc) page_instance_init, &g_define_type_value_table };
		static const GTypeFundamentalInfo g_define_type_fundamental_info = { (G_TYPE_FLAG_CLASSED | G_TYPE_FLAG_INSTANTIATABLE | G_TYPE_FLAG_DERIVABLE | G_TYPE_FLAG_DEEP_DERIVABLE) };
		GType page_type_id;
		page_type_id = g_type_register_fundamental (g_type_fundamental_next (), "Page", &g_define_type_info, &g_define_type_fundamental_info, 0);
		Page_private_offset = g_type_add_instance_private (page_type_id, sizeof (PagePrivate));
		g_once_init_leave (&page_type_id__volatile, page_type_id);
	}
	return page_type_id__volatile;
}


gpointer
page_ref (gpointer instance)
{
	Page * self;
	self = instance;
#line 20 "../src/page.vala"
	g_atomic_int_inc (&self->ref_count);
#line 20 "../src/page.vala"
	return instance;
#line 4210 "page.c"
}


void
page_unref (gpointer instance)
{
	Page * self;
	self = instance;
#line 20 "../src/page.vala"
	if (g_atomic_int_dec_and_test (&self->ref_count)) {
#line 20 "../src/page.vala"
		PAGE_GET_CLASS (self)->finalize (self);
#line 20 "../src/page.vala"
		g_type_free_instance ((GTypeInstance *) self);
#line 4225 "page.c"
	}
}


static void
_vala_array_destroy (gpointer array,
                     gint array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		int i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}


static void
_vala_array_free (gpointer array,
                  gint array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}



